% Matlab M-file for Example 10.2: ex10_2.m
% *** Copyright 2016 by G. W. Chang *** %
% *** All rights reserved *** %
% Clean previous value
clc
clear all
%Initial value
Vf=complex(1,0);
Z33_1=complex(0,0.1696);
Z33_2=complex(0,0.1696);
Z33_0=complex(0,0.1999);
Zbus0=[0.1553i 0.1407i 0.0493i 0.0347i;
              0.1407i 0.1999i 0.0701i 0.0493i;
              0.0493i 0.0701i 0.1999i 0.1407i;
              0.0347i 0.0493i 0.1407i 0.1553i];
Z43_0=complex(0,0.1407);
Z43_1=complex(0,0.1211);
Z43_2=complex(0,0.1211);
a=complex(-0.5,0.866);
%Caculate falt current
Ifa0=Vf/(Z33_1+Z33_2+Z33_0);
disp(['Zero-sequence current in the fault is j',num2str(abs(Ifa0)),' per unit'])
Ifa1=Ifa0;
Ifa2=Ifa0;
%Caculata total fault current
Ifa_unit=3*Ifa0;
Ifa_unit_mag=abs(Ifa_unit);                              %Convert radian to degree
Ifa_unit_ang=angle(Ifa_unit)*180/pi;
disp(['Current in the fault is ',num2str(Ifa_unit_mag),'',num2str(Ifa_unit_ang),' per unit'])
Ibase=100000/(sqrt(3)*345);
Ifa=Ifa_unit*Ibase;
%Caculate fault voltage
V4a_0=-Z43_0*Ifa0;
V4a_1=Vf-Z43_1*Ifa1;
V4a_2=-Z43_2*Ifa2;
%Fault voltage in each phase
Vabc=[1 1 1;1 a^2 a;1 a a^2]*[V4a_0;V4a_1;V4a_2];
Vbase=20/sqrt(3);
disp('Voltages at bus 4 as follows:')
V4a=Vabc(1,1)*Vbase;
V4a_mag=abs(V4a);                              %Convert radian to degree
V4a_ang=angle(V4a)*180/pi;
disp([' V4a=',num2str(V4a_mag),'',num2str(V4a_ang),' V']);
V4b=Vabc(2,1)*Vbase;
V4b_mag=abs(V4b);                              %Convert radian to degree
V4b_ang=angle(V4b)*180/pi;
disp([' V4b=',num2str(V4b_mag),'',num2str(V4b_ang),' V']);
V4c=Vabc(3,1)*Vbase;
V4c_mag=abs(V4c);                              %Convert radian to degree
V4c_ang=angle(V4c)*180/pi;
disp([' V4c=',num2str(V4c_mag),'',num2str(V4c_ang),' V']);
%Caculate fault current of phase a
X1=0.2i;    %X"=X1=X2
X0=0.04i;
Xn=0.05i;

Ia0=-V4a_0/(X0+3*Xn);
Ia0_mag=abs(Ia0);                  %Convert radian to degree
Ia0_ang=angle(Ia0)*180/pi;
disp(['Zero-sequence current out of the machine is ',num2str(Ia0_mag),'',num2str(Ia0_ang),' per unit'])
Ia1=(Vf-V4a_1)/X1;
Ia1_mag=abs(Ia1);                  %Convert radian to degree
Ia1_ang=angle(Ia1)*180/pi;
disp(['Positive-sequence current out of the machine is ',num2str(Ia1_mag),'',num2str(Ia1_ang),' per unit'])
Ia2=-V4a_2/X1;
Ia2_mag=abs(Ia2);                  %Convert radian to degree
Ia2_ang=angle(Ia2)*180/pi;
disp(['Negitive-sequence current out of the machine is ',num2str(Ia2_mag),'',num2str(Ia2_ang),' per unit'])
Ic=Ia0+a*Ia1+a^2*Ia2;
Ic_mag=abs(Ic);                  %Convert radian to degree
Ic_ang=angle(Ic)*180/pi;
disp(['The phase-c currents in machine 2 is ',num2str(Ic_mag),'',num2str(Ic_ang),' per unit'])