% Matlab M-file of Example 10.3: ex10_3.m
% *** Copyright 2016 by G. W. Chang *** %
% *** All rights reserved *** %
% Clean previous value
clc
clear all
% Initial values
Vf=1;
S=100*10^6;%VA
V=345*10^3;%V
V_machine2=20*10^3;%V
Zbus_0=[j*0.1553    j*0.1407    j*0.0493    j*0.0347;
        j*0.1211    j*0.1696    j*0.0701    j*0.0493;
        j*0.0493    j*0.0701    j*0.1999    j*0.1407;
        j*0.0347    j*0.0493    j*0.1407    j*0.1553];
% Get from Example 10.1
Zbus_1=[j*0.1437    j*0.1211    j*0.0789    j*0.0563;
        j*0.1211    j*0.1696    j*0.1104    j*0.0789;
        j*0.0789    j*0.1104    j*0.1696    j*0.1211;
        j*0.0563    j*0.0789    j*0.1211    j*0.1437];
Zbus_2=Zbus_1;
X0=j*0.04;
Xn3=j*0.15;
Xf=j*0.2;
% Get from Example 10.2
Ibase=167.35;%A
Vbase=345/sqrt(3);%kV
Vbase_low=20/sqrt(3);%kV
% Solution 
% line to line fault current
IfA1=Vf/(Zbus_1(3,3)+Zbus_2(3,3));
IfA2=-IfA1;
IfA_pu=IfA1+IfA2;
IfB_pu=IfA1*(cosd(240)+j*sind(240))+IfA2*(cosd(120)+j*sind(120));
IfC_pu=-IfB_pu;
disp('As in Example 10.2, base current in the transmission line is 167.35 A, and so')
IfA=IfA_pu*Ibase;
IfA_mag=abs(IfA);
IfA_ang=angle(IfA)*180/pi;  %rad->degree
IfB=IfB_pu*Ibase;
IfB_mag=abs(IfB);
IfB_ang=angle(IfB)*180/pi;  %rad->degree
IfC=IfC_pu*Ibase;
IfC_mag=abs(IfC);
IfC_ang=angle(IfC)*180/pi;  %rad->degree
disp(['  IfA= ',num2str(IfA_mag),'',num2str(IfA_ang),' A'])
disp(['  IfB= ',num2str(IfB_mag),'',num2str(IfB_ang),' A'])
disp(['  IfC= ',num2str(IfC_mag),'',num2str(IfC_ang),' A'])
% voltages at fault bus 3
V3A0_pu=0;
V3A1_pu=1-Zbus_1(3,3)*IfA1;
V3A2_pu=V3A1_pu;
V3A_pu=V3A0_pu+V3A1_pu+V3A2_pu;
V3B_pu=V3A0_pu+V3A1_pu*(cosd(240)+j*sind(240))+V3A2_pu*(cosd(120)+j*sind(120));
V3C_pu=V3B_pu;
V3AB_pu=V3A_pu-V3B_pu;
V3BC_pu=V3B_pu-V3C_pu;
V3CA_pu=V3C_pu-V3A_pu;
disp('Voltages at fault bus 3 are')
V3AB=V3AB_pu*Vbase;
V3AB_mag=abs(V3AB);
V3AB_ang=angle(V3AB)*180/pi;  %rad->degree
V3BC=V3BC_pu*Vbase;
V3BC_mag=abs(V3BC);
V3BC_ang=angle(V3BC)*180/pi;  %rad->degree
V3CA=V3CA_pu*Vbase;
V3CA_mag=abs(V3CA);
V3CA_ang=angle(V3CA)*180/pi;  %rad->degree
disp(['  V3AB= ',num2str(V3AB_mag),'',num2str(V3AB_ang),' kV'])
disp(['  V3BC= ',num2str(V3BC_mag),'',num2str(V3BC_ang),' kV'])
disp(['  V3CA= ',num2str(V3CA_mag),'',num2str(V3CA_ang),' kV'])
% voltages at fault bus 4
% V4A
V4A0_pu=0;
V4A1_pu=Vf-Zbus_1(4,3)*IfA1;
V4A2_pu=-Zbus_2(4,3)*IfA2;
V4A0_pu=V4A0_pu;
V4A1_pu=V4A1_pu*(cosd(-30)+j*sind(-30));
V4A2_pu=V4A2_pu*(cosd(30)+j*sind(30));
V4A_pu=V4A0_pu+V4A1_pu+V4A2_pu;
% V4B
V4B0_pu=V4A0_pu;
V4B1_pu=V4A1_pu*(cosd(240)+j*sind(240));
V4B2_pu=V4A2_pu*(cosd(120)+j*sind(120));
V4B_pu=V4B0_pu+V4B1_pu+V4B2_pu;
% V4C
V4C0_pu=V4A0_pu;
V4C1_pu=V4A1_pu*(cosd(120)+j*sind(120));
V4C2_pu=V4A2_pu*(cosd(240)+j*sind(240));
V4C_pu=V4C0_pu+V4C1_pu+V4C2_pu;
% V4line
V4AB_pu=V4A_pu-V4B_pu;
V4BC_pu=V4B_pu-V4C_pu;
V4CA_pu=V4C_pu-V4A_pu;
disp('Voltages at fault bus 4 are')
V4AB=V4AB_pu*Vbase_low;
V4AB_mag=abs(V4AB);
V4AB_ang=angle(V4AB)*180/pi;  %rad->degree
V4BC=V4BC_pu*Vbase_low;
V4BC_mag=abs(V4BC);
V4BC_ang=angle(V4BC)*180/pi;  %rad->degree
V4CA=V4CA_pu*Vbase_low;
V4CA_mag=abs(V4CA);
V4CA_ang=angle(V4CA)*180/pi;  %rad->degree
disp(['  V4AB= ',num2str(V4AB_mag),'',num2str(V4AB_ang),' kV'])
disp(['  V4BC= ',num2str(V4BC_mag),'',num2str(V4BC_ang),' kV'])
disp(['  V4CA= ',num2str(V4CA_mag),'',num2str(V4CA_ang),' kV'])
