% Matlab M-file for Example 10.4: ex10_4.m
% *** Copyright 2016 by G. W. Chang *** %
% *** All rights reserved *** %
% Clean previous value
clc
clear all
%Initial value
Vf=complex(1,0);
Z44_0=complex(0,0.19);
Z44_1=complex(0,0.1437);
Z44_2=complex(0,0.1437);
a=cosd(120)+sind(120)*i;
%Caculate fault current
Ifa1=Vf/(Z44_1+(Z44_2*Z44_0/(Z44_2+Z44_0)));
Ifa0=-Ifa1*(Z44_2/(Z44_2+Z44_0));
Ifa2=-Ifa1*(Z44_0/(Z44_2+Z44_0));
%Fault current in phase
Ifa_unit=Ifa0+Ifa1+Ifa2;
Ifb_unit=Ifa0+a^2*Ifa1+a*Ifa2;
Ifc_unit=Ifa0+a*Ifa1+a^2*Ifa2;
%Caculate total fault current
If_unit=Ifb_unit+Ifc_unit;
Ibase=100000/(sqrt(3)*20);
disp('**************Fault current in A**************')
Ifa=0;
Ifa_mag=abs(Ifa);
Ifa_ang=angle(Ifa)*180/pi;
Ifb=Ifb_unit*Ibase;
Ifb_mag=abs(Ifb);
Ifb_ang=angle(Ifb)*180/pi;
Ifc=Ifc_unit*Ibase;
Ifc_mag=abs(Ifc);
Ifc_ang=angle(Ifc)*180/pi;
If=If_unit*Ibase;
If_mag=abs(If);
If_ang=angle(If)*180/pi;
disp(['  Ifa = Ifa0+Ifa1+Ifa2 = ',num2str(Ifa_mag),'',num2str(Ifa_ang),' A']);
disp(['  Ifb = Ifa0+a^2*Ifa1+a*Ifa2 = ',num2str(Ifb_mag),'',num2str(Ifb_ang),' A']);
disp(['  Ifc = Ifa0+a*Ifa1+a^2*Ifa2 = ',num2str(Ifc_mag),'',num2str(Ifc_ang),' A']);
disp(['  Ifa = Ifa0+Ifa1+Ifa2 = ',num2str(If_mag),'',num2str(If_ang),' A']);
%Caculate fault voltage
V4a_1=Vf-Ifa1*Z44_1;
V4a_2=V4a_1;
V4a_0=V4a_1;
V4a=V4a_0+V4a_1+V4a_2;
V4b=0;   %Bolted ground
V4c=0;
V4ab_unit=V4a-V4b;
V4bc_unit=V4b-V4c;
V4ca_unit=V4c-V4a;
disp('**************Fault voltage in kV**************')
Vbase=20/sqrt(3);
V4ab=V4ab_unit*Vbase;
V4ab_mag=abs(V4ab);
V4ab_ang=angle(V4ab)*180/pi;
V4bc=V4bc_unit*Vbase;
V4bc_mag=abs(V4bc);
V4bc_ang=angle(V4bc)*180/pi;
V4ca=V4ca_unit*Vbase;
V4ca_mag=abs(V4ca);
V4ca_ang=angle(V4ca)*180/pi;
disp(['  V4ab = V4a-V4b = ',num2str(V4ab_mag),'',num2str(V4ab_ang),' kV']);
disp(['  V4bc = V4b-V4c = ',num2str(V4bc_mag),'',num2str(V4bc_ang),' kV']);
disp(['  V4ca = V4c-V4a =',num2str(V4ca_mag),'',num2str(V4ca_ang),' kV']);