% Matlab M-file for Example 10.7: ex10_7.m
% *** Copyright 2016 by G. W. Chang *** %
% *** All rights reserved *** %
% Clean previous value
clc
clear all
%Initial value
Vf=complex(1,0);
Zpp_0=complex(0,0.24);
Zpp_1=complex(0,0.5);
a=cosd(120)+sind(120)*i;
%Caulate fault current
Zpp_0=0.6*0.4/(0.6+0.4)*i;
Zpp_1=0.5i;
Zpp_2=Zpp_1;
IfA1=Vf/(Zpp_0+Zpp_1+Zpp_2);
IfA0=IfA1;
IfA2=IfA1;
IfA=3*IfA0;
%Find point P' current of phase B
IfB1=a^2*IfA1;
IfB2=a*IfA2;
IfB0=IfA0;
IfB=IfB0+IfB1+IfB2;
IfC=0;
%Caculate cunrrent in sequence 0
disp('Zero sequence current,Toward P from T1:')
IA0_PtoT1=0.4/(0.4+0.6)*IfA0;
IA0_PtoT1_mag=abs(IA0_PtoT1);                              %Convert radian to degree
IA0_PtoT1_ang=angle(IA0_PtoT1)*180/pi;
disp([' IA0_PtoT1 = 0.4/(0.4+0.6)*IfA0 = ',num2str(IA0_PtoT1_mag),'',num2str(IA0_PtoT1_ang),' per unit']);
disp('Zero sequence current,Toward P from T2:')
Ia0_PtoT2=0.6/(0.4+0.6)*IfA0;
Ia0_PtoT2_mag=abs(Ia0_PtoT2);                              %Convert radian to degree
Ia0_PtoT2_ang=angle(Ia0_PtoT2)*180/pi;
disp([' Ia0_PtoT2 = 0.6/(0.4+0.6)*IfA0 = ',num2str(Ia0_PtoT2_mag),'',num2str(Ia0_PtoT2_ang),' per unit']);
%Find the current in transmission line
disp('Transmission line current:')
IA1_PtoT1=IfA1;
IA2_PtoT1=IfA2;
IA_PtoT1=IA0_PtoT1+IA1_PtoT1+IA2_PtoT1;
IA_PtoT1_mag=abs(IA_PtoT1);                              %Convert radian to degree
IA_PtoT1_ang=angle(IA_PtoT1)*180/pi;
disp([' IA_PtoT1 = IA0_PtoT1+IA1_PtoT1+IA2_PtoT1 = ',num2str(IA_PtoT1_mag),'',num2str(IA_PtoT1_ang),' per unit']);
IB_PtoT1=IA0_PtoT1+IA1_PtoT1*a^2+IA2_PtoT1*a;
IB_PtoT1_mag=abs(IB_PtoT1);                              %Convert radian to degree
IB_PtoT1_ang=angle(IB_PtoT1)*180/pi;
disp([' IB_PtoT1=IA0_PtoT1+IA1_PtoT1*a^2+IA2_PtoT1*a = ',num2str(IB_PtoT1_mag),'',num2str(IB_PtoT1_ang),' per unit']);
IC_PtoT1=IA0_PtoT1+IA1_PtoT1*a+IA2_PtoT1*a^2;
IC_PtoT1_mag=abs(IB_PtoT1);                              %Convert radian to degree
IC_PtoT1_ang=angle(IB_PtoT1)*180/pi;
disp([' IC_PtoT1 = IA0_PtoT1+IA1_PtoT1*a+IA2_PtoT1*a^2 = ',num2str(IC_PtoT1_mag),'',num2str(IC_PtoT1_ang),' per unit']);
IA_PtoT2=Ia0_PtoT2;
IA_PtoT2_mag=abs(IA_PtoT2);                              %Convert radian to degree
IA_PtoT2_ang=angle(IA_PtoT2)*180/pi;
disp([' IA_PtoT2 = Ia0_PtoT2 = ',num2str(IA_PtoT2_mag),'',num2str(IA_PtoT2_ang),' per unit']);
IB_PtoT2=Ia0_PtoT2;
IB_PtoT2_mag=abs(IB_PtoT2);                              %Convert radian to degree
IB_PtoT2_ang=angle(IB_PtoT2)*180/pi;
disp([' IB_PtoT2 = Ia0_PtoT2 = ',num2str(IB_PtoT2_mag),'',num2str(IB_PtoT2_ang),' per unit']);
IC_PtoT2=Ia0_PtoT2;
IC_PtoT2_mag=abs(IC_PtoT2);                              %Convert radian to degree
IC_PtoT2_ang=angle(IC_PtoT2)*180/pi;
disp([' IC_PtoT2 = Ia0_PtoT2 = ',num2str(IC_PtoT2_mag),'',num2str(IC_PtoT2_ang),' per unit']);
%Current of generator
disp('Generator current:')
Ia_012=[0; IfA1*(cosd(-30)+sind(-30)*i); IfA2*(cosd(30)+sind(30)*i)];
disp([' Ia_012 = [0; IfA1-30; IfA1+30]'])
Ia=Ia_012(1,1)+Ia_012(2,1)+Ia_012(3,1);
Ia_mag=abs(Ia);                              %Convert radian to degree
Ia_ang=angle(Ia)*180/pi;
Ib=Ia_012(1,1)+Ia_012(2,1)*a^2+Ia_012(3,1)*a;
Ib_mag=abs(Ib);                              %Convert radian to degree
Ib_ang=angle(Ib)*180/pi;
%Ic=Ia_012(1,1)+Ia_012(2,1)*a+Ia_012(3,1)*a^2;
Ic=-Ia-Ib;
if abs(Ic)<0.000001
    Ic=0;
end
Ic_mag=abs(Ic);                              %Convert radian to degree
Ic_ang=angle(Ic)*180/pi;
disp([' Ia = Ia_012(1,1)+Ia_012(2,1)+Ia_012(3,1) = ',num2str(Ia_mag),'',num2str(Ia_ang),' per unit']);
disp([' Ib = Ia_012(1,1)+Ia_012(2,1)*a^2+Ia_012(3,1)*a = ',num2str(Ib_mag),'',num2str(Ib_ang),' per unit']);
disp([' Ic = Ia_012(1,1)+Ia_012(2,1)*a+Ia_012(3,1)*a^2 = ',num2str(Ic_mag),'',num2str(Ic_ang),' per unit']);


