% Matlab M-file for Example 10.8: ex10_8.m
% *** Copyright 2016 by G. W. Chang *** %
% *** All rights reserved *** %
% Clean previous value 
clc
clear all
%Initial value
Z1=0.15i;
Z2=Z1;
Z0=0.5i;
Z22_1=0.1696i;
Z33_1=0.1696i;
Z23_1=0.1104i;
Z22_0=0.08i;
Z33_0=0.58i;
Z23_0=0.08i;
PF=0.8;
disp('Choose a base of 100MVA, 345kV in the tranmission line')
S=50/100;
V3=1+0i;
I23=0.5*(cosd(acosd(PF))-sind(acosd(PF))*i)/V3;
%Design the open-circuit point of the line as p and q
Zpq_1=-(Z1^2)/(Z22_1+Z33_1-2*Z23_1-Z1);
Zpq_2=Zpq_1;
Zpq_0=-(Z0^2)/(Z22_0+Z33_0-2*Z23_0-Z0);
disp('One open conductor')
Va_0=I23*Zpq_1*Zpq_2/(Zpq_1+Zpq_2);
Va_1=Va_0;
Va_2=Va_0;
dV3_1=(Z23_1-Z33_1)/Z1*Va_1;
dV3_1_mag=abs(dV3_1);                              %Convert radian to degree
dV3_1_ang=angle(dV3_1)*180/pi;
dV3_2=dV3_1;
disp([' dV3_1 = dV3_2 = (Z23_1-Z33_1)/Z1*Va_1 = ',num2str(dV3_1_mag),'',num2str(dV3_1_ang),' per unit']);
dV3_0=(Z23_0-Z33_0)/Z0*Va_0;
dV3_0_mag=abs(dV3_0);                              %Convert radian to degree
dV3_0_ang=angle(dV3_0)*180/pi;
disp([' dV3_0 = (Z23_0-Z33_0)/Z0*Va_0 = ',num2str(dV3_0_mag),'',num2str(dV3_0_ang),' per unit']);
disp('The change in voltage at bus 3')
dV3=dV3_1+dV3_2+dV3_0;
dV3_mag=abs(dV3);                              %Convert radian to degree
dV3_ang=angle(dV3)*180/pi;
disp([' dV3 = dV3_1+dV3_2+dV3_0 = ',num2str(dV3_mag),'',num2str(dV3_ang),' per unit']);
V3_new=V3+dV3;
V3_new_mag=abs(V3_new);                              %Convert radian to degree
V3_new_ang=angle(V3_new)*180/pi;
disp([' V3_new = V3+dV3= ',num2str(V3_new_mag),'',num2str(V3_new_ang),' per unit']);

