% Matlab M-file of Example 12.2: ex12_2.m
% Determine the saving in fuel cost in dollars per hour for the  economic 
% distribution of a totla load of 900MW between the two units of the plant
% descibed in Example 12.1 compared with equal distribution of the same
% totla load.

% *** Copyright 2016 by G. W. Chang *** %
% *** All rights reserved *** %
clc
clear all

p1=[0.008 8]; h=0.0001; 
a=400; 
b=450;
x=a:h:b;
y=polyval(p1,x);
lambda1=trapz(x,y);
                          % Integration dF1|dPg1 to calculate the increase
                          % in cost for Unit 1 at 400 ~ 450MW
p2=[0.0096 6.4]; h=0.0001; 
a=450; 
b=500;
x=a:h:b;
y=polyval(p2,x);
lambda2=0-trapz(x,y);
                          % Integration dF2|dPg2 to calculate the increase
                          % in cost for Unit 2 at 500 ~ 450MW
                          
fprintf('Table 12.1 shows that Unit 1 should supply 400MW and Unit 2 should supply 500MW.\nIf each unit suoolies 450 MW, the increase in cost for Unit 1 = $%.0f per hour \n',lambda1)
fprintf('The constant c1 cancels when we evaluate at the two limits. Similarly, for Unit 2 = $%.0f per hour\n',lambda2)
fprintf('The negative sign indicates a decrease in cost, as we expect for a decrease in output. \nThe net increase in cost is $%.0f $%.0f = $%.0f per hour. \n',lambda1,lambda2,lambda1+lambda2)
fprintf('The saving seems small, but this amount saved every hour for a year of continuous operation would reduce fuel cost by %.0f for the year.\n',(lambda1+lambda2)*365*24)

