% Matlab M-file for Example 12.7: ex 12-7.m
% *** Copyright 2016 by G. W. Chang *** %
% *** All rights reserved *** %

% Clean previous value
clc
clear all
%Initial value 
format long
a1=0.8;
a2=0.96;
b1=8;
b2=6.4;
% B is obtained from B_matrix in Example 12.6
B= [8.412231  -0.028725  0.380697;  
   -0.028725   5.981305  0.197142;
    0.380697   0.197142  0.092345].*10^(-3); 
lambda=9.454545;
PD=4.29;
B10=2*B(3,1);
B20=2*B(3,2);
B00=B(3,3);
disp('Given PD=5.00 per unit on a 100-MVA base')
disp('Choose lambda=9.454545 in first iteration')
%Suppose M*Pg=N
M=[a1/lambda+2*B(1,1)  2*B(1,2);
    2*B(2,1)          a2/lambda+2*B(2,2)];
N=[1-B10-b1/lambda;1-B20-b2/lambda];   
Pg=inv(M)*N;
PL=B(1,1)*Pg(1,1)^2+2*B(1,2)*Pg(1,1)*Pg(2,1)+B(2,2)*Pg(2,1)^2+B10*Pg(1,1)+B20*Pg(2,1)+B00;
check=PD+PL-(Pg(1,1)+Pg(2,1));
delta_lambda=lambda*(PD+PL-(Pg(1,1)+Pg(2,1)))/(Pg(1,1)+Pg(2,1));
k=0;
fprintf('Iteration\t\tLambda\t\t\tPg1(MW)\t\t\tPg2(MW)\t\t\tdelta_lambda\n')
while abs(check) > (10^(-4))
    Pg_pre=[Pg(1,1);Pg(2,1)];  %The value of Pg1,Pg2 in previous iteration
    lambda_pre=lambda;  %The value of lambda in previous iteration
    lambda=lambda+delta_lambda;
    M=[a1/lambda+2*B(1,1)  2*B(1,2);2*B(2,1)  a2/lambda+2*B(2,2)];
    N=[1-B10-b1/lambda;1-B20-b2/lambda] ;
    Pg=inv(M)*N;
    PL=B(1,1)*Pg(1,1)^2+2*B(1,2)*Pg(1,1)*Pg(2,1)+B(2,2)*Pg(2,1)^2+B10*Pg(1,1)+B20*Pg(2,1)+B00;
    check=PD+PL-(Pg(1,1)+Pg(2,1));
    delta_lambda=(lambda-lambda_pre)*(PD+PL-(Pg(1,1)+Pg(2,1)))/(Pg(1,1)+Pg(2,1)-Pg_pre(1,1)-Pg_pre(2,1));
    fprintf('\t%d\t\t\t%f\t\t%f\t\t%f\t\t%f\t\n',k,lambda,Pg(1,1)*100,Pg(2,1)*100,delta_lambda)
    k=k+1;
end
%Calculate the incremental fuel cost ($/MWh)
disp('Calculate the incremental fuel cost ($/MWh)')
cost1=a1*Pg(1,1)+b1;
disp([' cost1 = a1*Pg(1,1)+b1 = ',num2str(cost1),' $/MWh'])
cost2=a2*Pg(2,1)+b2;
disp([' cost2 = a2*Pg(2,1)+b2 = ',num2str(cost2),' $/MWh'])
%Calculate the penalty factor
disp('Calculate the penalty factor')
L1=1/(1-2*(B(1,1)*Pg(1,1)+B(1,2)*Pg(2,1)+B10/2));
disp([' L1 = 1/(1-2*(B(1,1)*Pg(1,1)+B(1,2)*Pg(2,1)+B10/2)) = ',num2str(L1)])
L2=1/(1-2*(B(2,2)*Pg(2,1)+B(2,1)*Pg(2,1)+B20/2));
disp([' L2 = 1/(1-2*(B(2,2)*Pg(2,1)+B(2,1)*Pg(2,1)+B20/2)) = ',num2str(L2)])
% calculating the production-cost reduction between the two load levels
disp('Calculating the production-cost reduction between the two load levels')
Pg_old=[190.2;319.1];%100MW
Pg_new=Pg.*100; %MW
syms Pg1 Pg2
a1=0.008;a2=0.0096;
b1=8;   b2=6.4;
df1=a1*Pg1+b1;
df2=a2*Pg2+b2;
delta_f1=double(int(df1,Pg1,Pg_old(1,1),Pg_new(1,1)));
disp([' delta_f1 = double(int(df1,Pg1,Pg_old(1,1),Pg_new(1,1))) = ',num2str(delta_f1),' $/h'])
delta_f2=double(int(df2,Pg2,Pg_old(1,1),Pg_new(1,1)));
disp([' delta_f2 = double(int(df2,Pg2,Pg_old(1,1),Pg_new(1,1))) = ',num2str(delta_f2),' $/h'])
% total reduction in system fuel cost
disp('Total reduction in system fuel cost')
delta_total_f=delta_f1+delta_f2;
disp([' delta_total_f = delta_f1+delta_f2 = ',num2str(delta_total_f),' $/h'])