% M-file for Example 12.6a- Using bisection method to solve Example 12.6: ex12_6a.m 
% The 4-bus, 2-generator power system serves a load level of 500 MW or PD=5 with B-coefficint matrix provided at 100 MVA base.
% For Example 12.7, change load level to PD = 4.29 to run the same program

% *** Copyright 2016 by G. W. Chang *** %
% *** All rights reserved *** %
clc 
clear all
PD=5;
% PD=4.29;
format long

B = 0.001*[8.4122313 -0.028725 0.380697;-0.028725 5.981305 0.197142; 0.380697 0.197142 0.092345];

dF1dPg = [0.008 8;0.0096 6.4];   
                                % dF/dPg = a*Pg + b = lunda;
                                % dF1dPg = [a b];
a = dF1dPg(:,1);
b = dF1dPg(:,2);
base=100;

%DiffValue(1) = 1;
%lambda(1)=9.454545; 
DiffValue(1) = 25;
lambda(1)=25;
Pg1(1) = 1.82;
Pg2(1) = 3.18;
                                % set initial value
                                % start guessing value from 0.01 ~ 100
                                % and slit into 2 part
fprintf('Iterations');          % Printf solutions
fprintf('\t\tLambda');
for j=1:2
  fprintf('\t\tUnit%d',j);      
end
fprintf('\tTotal Generation(MW)')
fprintf('\n');
    
for i =1:30

Lambd=lambda(i);
%J=[0.8/lambda(i)+2*8.383183*10^-3 -2*0.049448*10^-3;-2*0.049448*10^-3 0.96/lambda(i)+2*5.963568*10^-3];
%Q=[(1-0.750164*10^-3)-8/lambda(i);(1-0.389942*10^-3)-6.4/lambda(i)];
J=[0.8/lambda(i)+2*8.412231*10^-3 -2*0.028725*10^-3;-2*0.028725*10^-3 0.96/lambda(i)+2*5.981305*10^-3];
Q=[(1-0.761394*10^-3)-8/lambda(i);(1-0.394284*10^-3)-6.4/lambda(i)];

% [Q] = [J][Pg] => [Pg] = inv([j])*[Q]
Pg=J^(-1)*Q;
                                
Pg1(i)=Pg(1);
Pg2(i)=Pg(2);
PL(i)=B(1,1)*Pg1(i)^2+2*B(1,2)*Pg1(i)*Pg2(i)+B(2,2)*Pg2(i)^2+2*B(1,3)*Pg1(i)+2*B(3,2)*Pg2(i)+B(3,3);
                                %  P_demand + P_loss = Pg1 + Pg2
PG = Pg1(i)+Pg2(i)-PL(i);
    fprintf('%d\t\t\t\t',i);
    fprintf('%.4f',lambda(i));
    Pgtotal=0;
            fprintf('\t%9.4f',Pg1(i)*base);
            fprintf('\t%9.4f',Pg2(i)*base);
    Pgtotal = Pgtotal + Pg1(i)*base+Pg2(i)*base;
    fprintf('\t\t%10.4f',Pgtotal);
    fprintf('\n');
   
if PG-PD > 0                     % if more generation, reduce the value
    lambda(i+1)=lambda(i)-DiffValue/2;
   
elseif PG-PD < 0                 % if less than load, increase the value
    lambda(i+1)=lambda(i)+DiffValue/2;
    
else
    break;
end
if abs(PG-PD) < 1e-6            % convergence value
    break;
end

DiffValue=DiffValue/2;  

end
%i=i-1;

% calculate incremental losses of two plants by eq(12.45)
dPLldPg1=2*(B(1,1)*Pg1(i)+B(1,2)*Pg1(i)+B(1,3));
dPLldPg2=2*(B(2,2)*Pg2(i)+B(2,1)*Pg1(i)+B(3,1));

%  calculate penalty dactors of two plants by eq(12.21)
L1=1/(1-dPLldPg1);
L2=1/(1-dPLldPg2);

%  calculate incremental fuel costs of two plants
df1ldPg1=a(1)*Pg1(i)*base+b(1);
df2ldPg2=a(2)*Pg2(i)*base+b(2);
fprintf('\n');

fprintf('Lambda = %.6f $/MWh\n',lambda(i))
fprintf('Generator 1 output = %.6f MW\n',Pg1(i)*base)
fprintf('Generator 2 output = %.6f MW\n',Pg2(i)*base)
fprintf('Loss = %.6f MW\n',PL(i)*base)
fprintf('The incremental losses of the Unit 1 = %.6f,\nThe incremental losses of the Unit 2 = %.6f,\n',dPLldPg1,dPLldPg2)
fprintf('and so the penalty factors are given by L1 = %.6f;   L2 = %.6f\n',L1,L2)
fprintf('The incremental fuel costs at Unit 1 are calculated = %.6f $/MWh\nThe incremental fuel costs at Unit 2 are calculated = %.6f $/MWh\n',df1ldPg1,df2ldPg2)

