% Matlab M-file of Example 13.11: ex13_11.m
% *** Copyright 2016 by G. W. Chang *** %
% *** All rights reserved *** %
% Clean previous value
clc
clear all
% initial value
f=60;
H=8;
delta_t=0.015;
theta0=16.19;
Gamma=0.755;
% solution
k=180*f/H*(delta_t)^2;
% from Example 13.9
Pa(1)=1.6955-5.5023*sind(theta0-Gamma);
P(1)=5.5023*sind(theta0-Gamma);%when time=0
elec_deg(1)=theta0-Gamma;   %when time=0
Pa_ave=0.5*Pa;      %when time=0
kPa(1)=k*Pa_ave;     %when time=0
delta_theta(1)=0+kPa(1); %when time between 0 and 0.05 
theta(1)=theta0+delta_theta(1); %when time=0.05 

for i=2:51
    
    if i<16
        %during fault
        kPa(i)=k*(1.6955-5.5023*sind(theta(i-1)-Gamma));       
    else
        %clear fault
        kPa(i)=k*(1.6696-6.4934*sind(theta(i-1)-0.847));   
    end
        elec_deg(i)=theta(i-1)-Gamma;
        P(i)=5.5023*sind(theta(i-1)-Gamma);
        Pa(i)=kPa(i)/k;
        delta_theta(i)=delta_theta(i-1)+kPa(i);
        theta(i)=theta(i-1)+delta_theta(i);
end
%add theta0 into array
theta=[theta0 theta(1:50)];
time=0:0.015:0.75;
disp('     time    elec_deg    Pmax      Pa        kPa   delta_theta  theta')
disp([time',elec_deg',P',Pa',kPa',delta_theta',theta'])
disp('    time     angle1 ')
disp([time',theta'])
plot(time,theta), grid
title([' Machine 2 swing curve. Fault cleared at 0.225'])
xlabel('t, seconds')
ylabel('Delta, electrical degree')
ylim([0 40])  %limit display range of Y-axis

