% Matlab M-file of Example 13.9: ex13_9.m 
% *** Copyright 2016 by G. W. Chang *** %
% *** All rights reserved *** %
% Clean previous values
clc
clear all
% Initial values
XT14=j*0.022;
XT25=j*0.04;
Z34=0.007+j*0.04;
Z35_1=0.008+j*0.047;
Z35_2=0.008+j*0.047;
Z45=0.018+j*0.11;
y34line=j*0.082;
y35_1line=j*0.098;
y35_2line=j*0.098;
y45line=j*0.226;
G22=0.1362;
Y23=5.1665;
theta23=90.755;
%Generator 1
V1=1.03*(cosd(8.88)+j*sind(8.88));
P1=3.5; 
Q1=0.712; 
Xd1=j*0.067;
H1=11.2;%MJ/MVA
%Generator 2
V2=1.02*(cosd(6.38)+j*sind(6.38));
P2=1.85;
Q2=0.298;
Xd2=j*0.1;
H2=8;%MJ/MVA
%Load 1
VL1=1.018*(cosd(4.68)+j*sind(4.68));
PL1=1;
QL1=0.44;
%Load 2
VL2=1.011*(cosd(2.27)+j*sind(2.27));
PL2=0.5;
QL2=0.16;
% Solution
I1=conj(P1+j*Q1)/conj(V1);
I2=conj(P2+j*Q2)/conj(V2);
E1=V1+Xd1*I1;
E2=V2+Xd2*I2;
YL4=conj(PL1+j*QL1)/abs(VL1^2);
YL5=conj(PL2+j*QL2)/abs(VL2^2);
Y11=1/(Xd1+XT14);
Y34=1/Z34;
Y44=Y11+y34line/2+y45line/2+Y34+1/(Z45)+YL4;
Pe1=0;
E2G=abs(E2)^2*G22;
disp([' E2G = |E2|^2*G22 = ',num2str(E2G)])
EEY=abs(E2)*abs(Y23);
disp([' EEY = |E2|*|Y23| = ',num2str(EEY)])
Pe1=0;
%power-angle equations based on values from Table 16.5 are
fprintf('Power-Angle Equation:Pe2=%f+%fsin(delta-%f)\n',E2G,EEY,theta23-90)
% swing equations
% values of Pm1 and Pm2 from Table 16.3
Pm1=3.5;
Pm2=1.85;
fprintf('Swing Equation 1:180f/%f*(%f)\n',H1,Pm1-Pe1)%elec deg/s^2
fprintf('Swing Equation 2:180f/%f*[%f-%fsin(delta-%f)]\n',H2,Pm2-E2G,EEY,theta23-90)%elec deg/s^2


