% Matlab M-file for Example 2.1: ex2_1.m
% *** Copyright 2016 by G. W. Chang *** %
% *** All rights reserved *** %
% Clean previous value
clc
clear all
% Initial values
% According to the problem: P=50kW, Pf=0.8 lagging, V=220V
P=50000;      PF=0.8;    V=220;  
% System frequency=60 , improve the PF to 0.95
PFnew=0.95;   f=60;                                        
% Solution 
% The PF angle of initial system
theta=acosd(PF);                      
Q1=P*tand(theta);
% The PF angle of new system
theta_new=acosd(PFnew);
Q=P*tand(theta_new);
disp(['The PF angle of new system is 0.95'])
disp([' Q=P*tand(0.95)=',num2str(Q/1000),' kVAR'])
% The reactive power absorbed the capacitor
Q2=Q-Q1;
disp(['The reactive power absorbed the capacitor is Q2=Q-Q1'])
% The capacitance (in Farad) required to improve the PF to 0.95.
C=abs(Q2)/(2*pi*(V^2)*f)*1000;
disp(['The capacitance (in Farad) required to improve the PF to 0.95.'])
disp([' C=|Q2|/(2*pi*(V^2)*f)*1000=',num2str(C),' mF'])
disp(['The size of the required parallel capacitor is ',num2str(C),' mF'])
