% Matlab M-file for Example 2.2: ex2_2.m
% *** Copyright 2016 by G. W. Chang *** %
% *** All rights reserved *** %
% Clean previous value
clc
clear all
% Initial value
% According to Fig. 2.11, two ideal voltage sources are
E1=100;     E1angle=0;
E2=100;     E2angle=30;
Z=complex(0,5);
% Solution
% Convert degree to radian
E1cp=E1*cosd(E1angle)+j*E1*sind(E1angle);
E2cp=E2*cosd(E2angle)+j*E2*sind(E2angle);
% Calculate the current flowing from E1 to E2
disp('Calculate the current flowing from E1 to E2')
I=(E1cp-E2cp)/Z;
I_mag=abs(I);
I_ang=angle(I)/180*pi;
disp([' I=(E1cp-E2cp)/Z=',num2str(I_mag),'',num2str(I_ang),' A'])
% Calculate the apparent power delivered by two sources
% S=VI*
S1=E1cp*conj(-I);
S2=E2cp*conj(I);
disp('Calculate the apparent power delivered by two sources')
disp([' S1=E1cp*conj(-I)=',num2str(S1),' VA'])
disp([' S2=E2cp*conj(I)=',num2str(S2),' VA'])
% Calculate the reactive power absorbed by the series impedance
%Qa=abs(I)^2*abs(Z);
disp('Calculate the reactive power absorbed by the series impedance')
Qa=abs(S1+S2);
disp([' Qa=|S1+S2|=',num2str(Qa),' var'])
disp(['The reactive power absorbed in the series impedance is ',num2str(Qa),' var']);
