% Matlab M-file for Example 2.3: ex2_3.m
% *** Copyright 2016 by G. W. Chang *** %
% *** All rights reserved *** %
% Clean previous value
clc
clear all
% initial value
Vab=173.2;
ZL=10*cosd(20)+j*10*sind(20);
% solution
disp('With Vab as reference, the phasor diagram of voltages is drawn as shown in Fig. 2.18,')
disp('from which it is determined that')
Vab_mag=abs(Vab);
Vab_ang=angle(Vab)*180/pi;   % Rad => Degree
disp([' Vab=',num2str(Vab_mag),'',num2str(Vab_ang),' V']);
Vbc=Vab*(cosd(240)+j*sind(240));
Vbc_mag=abs(Vbc);
Vbc_ang=angle(Vbc)*180/pi;   % Rad => Degree
disp([' Vbc=',num2str(Vbc_mag),'',num2str(Vbc_ang),' V']);
Vca=Vab*(1*cosd(120)+j*1*sind(120));
Vca_mag=abs(Vca);
Vca_ang=angle(Vca)*180/pi;   % Rad => Degree
disp([' Vca=',num2str(Vca_mag),'',num2str(Vca_ang),' V']);
Van=Vab/sqrt(3)*(1*cosd(-30)+j*1*sind(-30));
Van_mag=abs(Van);
Van_ang=angle(Van)*180/pi;   % Rad => Degree
disp([' Van=',num2str(Van_mag),'',num2str(Van_ang),' V']);
Vbn=Vbc/sqrt(3)*(1*cosd(-30)+j*1*sind(-30));
Vbn_mag=abs(Vbn);
Vbn_ang=angle(Vbn)*180/pi;   % Rad => Degree
disp([' Vbn=',num2str(Vbn_mag),'',num2str(Vbn_ang),' V']);
Vcn=Vca/sqrt(3)*(1*cosd(-30)+j*1*sind(-30));
Vcn_mag=abs(Vcn);
Vcn_ang=angle(Vcn)*180/pi;   % Rad => Degree
disp([' Vcn=',num2str(Vcn_mag),'',num2str(Vcn_ang),' V']);
disp('Each current lags the voltage across its load impedance by 20 and each current magnitude is 10 A.')
Ian=Van/ZL;
Ian_mag=abs(Ian);
Ian_ang=angle(Ian)*180/pi;   % Rad => Degree
disp([' Ian=',num2str(Ian_mag),'',num2str(Ian_ang),' A']);
Ibn=Vbn/ZL;
Ibn_mag=abs(Ibn);
Ibn_ang=angle(Ibn)*180/pi;   % Rad => Degree
disp([' Ibn=',num2str(Ibn_mag),'',num2str(Ibn_ang),' A']);
Icn=Vcn/ZL;
Icn_mag=abs(Icn);
Icn_ang=angle(Icn)*180/pi;   % Rad => Degree
disp([' Icn=',num2str(Icn_mag),'',num2str(Icn_ang),' A']);