% Matlab M-file for Example 2.6: ex2_6.m
% *** Copyright 2016 by G. W. Chang *** %
% *** All rights reserved *** %
% Clean previous value
clc
clear all
% Initial the data from ex2.6
Vbase=4400;
Ibase=127;
% Initial the data get from ex2.3
Vline=4400;                              
ZL=1.4;       ZL_angle=75;
Zline=20;     Zline_angle=30;
% Convert polar form to rectangular form
ZL_cp=ZL*cosd(ZL_angle)+j*ZL*sind(ZL_angle); 
Zline_cp=Zline*cosd(Zline_angle)+j*Zline*sind(Zline_angle);
% Calculate voltage and current in phase
Van=Vline/sqrt(3);
Ian=Van/Zline_cp;
% Solution
% Turning the value into pu form
Zbase=(4400/sqrt(3))/127;
disp([' Zbase=(4400/sqrt(3))/127=',num2str(Zbase),' ['])
disp(['Base impedance is ',num2str(Zbase),' ['])
Z=ZL_cp/Zbase;
Z_mag=abs(Z);
Z_ang=angle(Z)*180/pi;
disp([' Z=ZL_cp/Zbase=',num2str(Z_mag),'',num2str(Z_ang),' per unit'])
disp(['The line impedance is ',num2str(Z_mag),'',num2str(Z_ang),' per unit'])
Ian_pu=Ian/Ibase;
% Calculate voltage in phase a and turn it into line-line voltage
Van=complex(1,0)+Ian_pu*Z;
Van_mag=abs(Van);
Van_ang=angle(Van)*180/pi;
disp([' Van=1+Ian*Z=',num2str(Van_mag),'',num2str(Van_ang),' per unit'])
disp(['The line-to-neutral voltage at the substation Van is ',num2str(Van_mag),' per unit with angle of ',num2str(Van_ang),' deg.'])
VLN=abs(Van)*Vbase/sqrt(3);
disp([' VLN=|Van/sqrt(3)|=',num2str(VLN),' V'])
disp(['The magnitude of line-to-neutral voltage at the substation bus is ',num2str(VLN),' V']);
VLL=abs(Van)*Vbase;
disp([' VLL=|Van|=',num2str(VLL),' V'])
disp(['The magnitude of line-to-line voltage at the substation bus is ',num2str(abs(VLL)),' V']);
