% Matlab M-file for Example 3.15: ex3_15.m
% *** Copyright 2016 by G. W. Chang *** %
% *** All rights reserved *** %
% Clean previous value
clc
clear all
%Initial value
f=60;  w=2*pi*f;
Ls=2.7656*10^(-3); Ms=1.3828*10^(-3); Mf=31.6950*10^(-3);
Sb=635*10^6;
va_mag=19565;
disp(['Base kVa = ',num2str(Sb/1000),' kVA'])
VLLb=24*10^3;
disp(['Base line voltage = ',num2str(VLLb/1000),' kV'])
Ib=Sb/(sqrt(3)*VLLb);
disp(['Base current = ',num2str(Ib),' A'])
Zb=VLLb^2/Sb; Xd=w*(Ls+Ms);
disp(['Base impedance =  ',num2str(Zb),' ['])
Xd_pu=Xd/Zb;
disp(['In per unit : Xd = ',num2str(Xd_pu),' ['])
%For per unit ,calculate the lagging Ia
Va=1; Ia_mag=1; Ia_ang=25.8419;
Ia=Ia_mag*(cosd(-Ia_ang)+j*sind(-Ia_ang));
Ei=Va+j*Xd_pu*Ia;
Ei_mag=abs(Ei);
Ei_ang=angle(Ei)*180/pi;   % Rad => Degree
disp(['In per unit : Ei = Va + jXd*Ia = ',num2str(Ei_mag),'',num2str(Ei_ang),' V'])
%Field current
If=va_mag/(w*Mf);
disp(['Rated terminal volatge required field current If = sqrt(2)*va_mag/(120*pi*Mf) = ',num2str(If),' A'])
Iexc=Ei_mag*If;
disp(['Required field current If = sqrt(2)*Ei_mag/(120*pi*Mf) = ',num2str(Iexc),' A'])
