% Matlab M-file of Example 3.18: ex3_18.m
% *** Copyright 2016 by G. W. Chang *** %
% *** All rights reserved *** %
% Clean previous value
clc
clear all
% initial value
V=22.8*10^3;%V
S=458.47+j*114.62;%MVA
Sbase=635;%MVA
Vbase=24*10^3;%V
Xd=1.7241;
% solution
% (a) Terminal voltage as the reference phasor
disp('(a) Terminal voltage as the reference phasor')
Vt=V/Vbase;
S_pu=S/Sbase;
Ia=conj(S_pu)/Vt;
Ei=Vt+j*Xd*Ia;
Ei_mag=abs(Ei);
Ei_mag_act=Vbase*Ei_mag;
Ei_ang=angle(Ei)*180/pi;
disp(['  Ei=Vt+j*Xd*Ia'])
disp([' Excitation voltage is ',num2str(Ei_mag),' per unit  or'])
disp([' Excitation voltage is ',num2str(Ei_mag_act),' V'])
% (b) The point k corresponding to the actual operating conditions
disp('(b) The point k corresponding to the actual operating conditions')
Sk=S_pu/Vt^2;
% The distance n-k equals 1.1173
distance=1.1173;
Ei_abs=distance*Vt^2*Xd/Vt;
disp(['  Ei_abs=distance*Vt^2*Xd/Vt'])
disp([' Excitation voltage is ',num2str(Ei_abs),' per unit'])
