% Matlab M-file for Example 3.2: ex3_2.m
% *** Copyright 2016 by G. W. Chang *** %
% *** All rights reserved *** %
% Clean previous value
clc
clear all
% Initial values
% Turns ratio
N1=2000;
N2=500;
% Winding resistance
r1=2;
r2=0.125;
% Leakage reactance
x1=8;
x2=0.5;
% Resistive load
Z2=12;
% Voltage at the terminal of primary side
V1=1200;
% Solution
a=N1/N2;
R1=r1+r2*(a)^2;
X1=x1+x2*(a)^2;
Z2new=Z2*(a)^2;
I1=V1/(R1+j*X1+Z2new);
aV2=I1*Z2new;
V2=aV2/a;
V2_mag=abs(V2);
V2_ang=angle(V2)*180/pi;   % Rad => Degree
disp([' V2_FL=aV2/a=',num2str(V2_mag),'',num2str(V2_ang),' V']);
V2_NL=V1/a;
V2_FL=V2;
voltage_regulation=(abs(V2_NL) -abs(V2_FL))/abs(V2_FL);
disp([' V.R.=(|V2_NL|-|V2_FL|)/|V2_FL|=',num2str(voltage_regulation)]);
disp(['Voltage regulation=',num2str(voltage_regulation*100),' %',]);