% M-file for Example 4.1: ex4_1.m
% *** Copyright 2016 by G. W. Chang *** %
% *** All rights reserved *** %
% Clean previous value
clc
clear all
% Initial values
size=(1113*10^3)*(5.067*10^(-4)); % m^2
t1=20;       % Temperature (Celsius degrees)
t2=50;       % Temperature (Celsius degrees)
R0=0.05118;  % ohm per 1000 m
R2=0.05942;   % ohm/km
% Solution
% At t=20 (Celsius degrees) from Eq. (4.2) with an increase of 2% for concentrically stranded conductors
disp('Calculate density of Alumium at 20 XC ')
disp([' Alumium at 20 XC is ',num2str(R0),' [ per 1000 m '])
% At t=50 (Celsius degrees) from Eq. (4.3)
disp('Calculate density of Allumium at 50 XC by the density of Alumium at 20 XC')
R0_2=R0*(228+t2)/(228+t1);    % ohm per 1000 m
disp('  R_50C=R_20C*(228+50)/(228+20);')
disp([' Alumium at 50 XC is ',num2str(R0_2),' [ per 1000 m '])
% Skin effect causes a 3.7% increase in resistance
ratio=R2/R0_2;   
ratio=ratio*100;
disp([' Skin effect causes a ',num2str(ratio-100),'% increase in resistance '])