% Matlab M-file for Example 4.5: ex4_5.m
% *** Copyright 2016 by G. W. Chang *** %
% *** All rights reserved *** %
% Clean previous value
clc
clear all
% Initial value 
Ds=0.0466;  % ft (from Table A.3)
d=0.45;     % m
Dab=8;  Dbc=Dab;    % m (from Fig. 4.9)
Dac=16;                    % m (from Fig. 4.9)
V=345;                      % kV
S=100;                      % MVA
l=160;                       % km
f=60;                         % Hz
% Solution
Dsb=sqrt(Ds*0.3048*d);         % Multiply feet by 0.3048 to convert to meter
Deq=nthroot(Dab*Dbc*Dac, 3); 
XL=2*pi*f*2*10^(-7)*10^3*log(Deq/Dsb);      % ohm/km per phase
XL_2=XL*1.609;          % ohm/mi per phase
Base_Z=(V^2)/S;           % ohm
X=(XL*l)/Base_Z;        % pu
disp([' X = (X_pu*length_of_line)/Base_Z = ',num2str(X),' [/km per phase'])
disp(['Each conductor of the bundled-conductor line is ',num2str(X),' [/km per phase'])