% M-file for Example5.3:ex5_3.m
% *** Copyright 2016 by G. W. Chang *** %
% *** All rights reserved *** %
% Clean previous value
clc
clear
Deq = nthroot(23.8*23.8*47.6,3);
z = 0.1603+(0.415i+0.4127i);
mag_z = abs(z)/1.609;      % Magnitude
ang_z = angle(z)*180/pi;   % Rad => Degree
y = i*(1/(0.095+0.1009))*10^(-6);
mag_y = abs(y)/1.609;  ang_y = angle(y)*180/pi;
mag_rl = 370*sqrt(mag_z*mag_y);  ang_rl = (ang_z+ang_y)/2;
mag_Zc = sqrt(mag_z/mag_y);  ang_Zc = (ang_z-ang_y)/2;
%Receiving end voltage and current
VR = 215*10^3/sqrt(3);  IR = 125*10^6/(sqrt(3)*215*10^3);
coshrl = 0.4654+0.2394i+0.4248-0.2185i;
sinhrl = 0.4654+0.2394i-(0.4248-0.2185i);
%Sending end voltage 
Vs=VR*0.8904*(cosd(1.34)+i*sind(1.34))+335.7*406.4*(cosd(-5.48)...
+i*sind(-5.48))*0.4597*(cosd(84.93)+i*sind(84.93));
mag_Vs = abs(Vs);  ang_Vs = angle(Vs)*180/pi;
%Sending end current
Is=IR*0.8904*(cosd(1.34)+i*sind(1.34))+124130/(406.4*(cosd(-5.48)...
+i*sind(-5.48)))*0.4597*(cosd(84.93)+i*sind(84.93));
mag_Is = abs(Is);  ang_Is = angle(Is)*180/pi;
%Line voltage (current)
disp('At the sending end');
VL = sqrt(3)*mag_Vs;
disp(['Line voltage= ',num2str(VL),' kV']);
IL = mag_Is;
disp(['Line current= ',num2str(IL),' A']);
format long 
PF = cosd(ang_Vs-ang_Is);
disp(['Power factor= ',num2str(PF)]);
format short 
Power = sqrt(3)*VL*IL*PF;
disp(['Power= ',num2str(Power/1000),' kW']);
Vregulation =((mag_Vs/1000)/abs(coshrl)-(VR/1000))/(VR/1000)*100;
disp(['Voltage regulation is ',num2str(Vregulation),' %']);
B = 0.475/370;  wavelength = 2*pi/B;
Velocity = 60*wavelength;
disp([' Wavelength = 2*pi/B = ',num2str(wavelength)])
disp([' Velocity = 60*wavelength = ',num2str(Velocity)])
disp(['Wavelength= ',num2str(wavelength),' km']);
disp(['Velocity= ',num2str(Velocity),' km/s']);