% M_File for Example 6.2: ex6_2.m
% *** Copyright 2016 by G. W. Chang *** %
% *** All rights reserved *** %
% Clean previous value
clc
clear all
% initial value 
disp('Get admittance matrix from example 6.1')
Y=[-j*14.5  j*8.0   j*4.0  j*2.5;
    j*8.0  -j*17.0  j*4.0  j*5.0;
    j*4.0   j*4.0  -j*8.8   0.0;
    j*2.5   j*5.0     0.0 -j*8.3]
disp('Get K,L,M from admittance matrix')    
K=[-j*14.5   j*8;   j*8     -j*17]
L=[ j*4     j*2.5;  j*4     j*5]
M=[-j*8.8       0;    0   -j*8.3]
V3=1.25;  V3angle=0;                      
V4=0.85;  V4angle=-45; % Degree
det_K=det(K);    % inv(K);
K_cal=[K(2,2) -K(1,2); -K(2,1) K(1,1)];
inv_K=K_cal/det_K;
LKL=L.'*inv(K)*L;
disp('Eliminate nodes 1 and 2 by the matrix-algebra procedure')
disp([' Ye_bus = M - LKL '])
Ye_bus=M-LKL
Z3=Ye_bus(2,2)-(-Ye_bus(1,2));
X3=abs(1/Z3);  X4=X3;
X34=abs(1/(-Ye_bus(1,2)));
V4cp=V4*cosd(V4angle)+j*V4*sind(V4angle);  
I=(V3-V4cp)/(j*(X3+X4+X34));
I_mag=abs(I);  I_ang=angle(I)*180/pi;
disp('Using new admittance matrix to calculate power and reactive voltamperes')
% Power out of source V3 and Power into source V4
Power_V3=V3*I';
disp([' Power out of source V3 is ',num2str(Power_V3),' per unit'])
Power_V4=V4cp*I';
disp([' Power into source V4 is ',num2str(Power_V4),' per unit'])
% The reactive voltamperes in the circuit equal
Q=abs(I)^2*(X3+X3+X34);
% The voltage at node 3 
V_3=V3-j*X3*I;
V3_mag=abs(V_3);   V3_ang=angle(V_3)*180/pi;
disp([' The voltage at node 3 is ',num2str(V_3),' per unit'])