% Matlab M-file for Example 7.11: ex7_11.m
% *** Copyright 2016 by G. W. Chang *** %
% *** All rights reserved *** %
% Clean previous value
clc
clear all
% Initial value
V1=1;
V3=0.969;
Vs=230;      % kV
S=complex(98.12,65.085);
S_2=complex(97.09,59.932);
R=0.00744;    % pu, from Table 7.7
X=0.03720;    % pu, from Table 7.7
% Solution
I=abs(S)*1000/(3^(1/2)*Vs*V1)        % A, calculate value of I
I_2=abs(S_2)*1000/(3^(1/2)*Vs*V3);    % A, calculate value of I_2
Zbase=(Vs^2)/100;                     % ohm
% Calculate the loss of real part
R_loss=3*I^2*R*Zbase*10^-6;     % MW
disp('Calculate the loss of real part')
disp([' I^2*R loss is ',num2str(R_loss),' MW'])
% Calculate the loss of imaginary part
X_loss=3*I^2*X*Zbase*10^-6;     % Mvar
disp('Calculate the loss of imaginary part')
disp([' I^2*X loss is ',num2str(X_loss),' Mvar'])