% Matlab M-file for Example 7.14: ex7_14.m
% *** Copyright 2016 by G. W. Chang *** %
% *** All rights reserved *** %
% Clean previous value
clc
clear all
% Initial value
% From Table 7.8
Q2=-1.0535;    
Q3=-1.2394;    
V1=1;,V2=1;,V3=1;,V4=1.02;  
disp('B matrix can be read directly from Table 7.9')
B=[44.835953        0       -25.847809; 
    0          40.863838    -15.118528;
   -25.847809  -15.118528   40.863838]
delta_P=[-1.59661;-1.93953;2.21286];
% Finding theta in rad
delta_theta=inv(B)*delta_P;  
delta2=delta_theta(1,1);
delta3=delta_theta(2,1);
delta4=delta_theta(3,1);
% Adding these results to the flat-start estimates
deltaQ2_divide_V2=1/1*(Q2+(V2^2)*-B(1,1)+19.455965*sin(101.30993*pi/180+0-delta2)...
                              +26.359695*V4*sin(101.30993*pi/180+delta4-delta2));
deltaQ3_divide_V3=1/1*(Q3+(V3^2)*-B(3,3)+26.359695*sin(101.30993*pi/180+0-delta3)...
                              +15.417934*V4*sin(101.30993*pi/180+delta4-delta3));
% Using B*delta_V=Q_divide_V to solve the problem
disp('Using B*delta_V=Q_divide_V to solve the problem')
B_new=[44.835953 0; 0 40.863838];
Q_divide_V=[deltaQ2_divide_V2;deltaQ3_divide_V3];
delta_V=inv(B_new)*Q_divide_V;
 % Show the answer
disp(' delta_V=inv(B_new)*Q_divide_V')
delta_V2=delta_V(1,1); 
delta_V3=delta_V(2,1);
disp([' delta_V2 = ',num2str(delta_V2)])
disp([' delta_V3 = ',num2str(delta_V3)])