% Matlab M-file for Example 7.5: ex7_5.m@
% *** Copyright 2016 by G. W. Chang *** %
% *** All rights reserved *** %
% Clean previous value
clc
clear all
% The initial solutions : x1=x2=x3=1
x = [1 ;1; 1];
deltax =[10;10;10];              % Assuming deltax is greater than 0.0001
i=1;                          % Iteration count : i
disp('Solve the following two nonlinear equations by using Newton-Raphson method')
fprintf('k \t\t\t   x1 \t\t\t\t   x2 \t\t\t\tx3\n');
while(max(abs(deltax))>=0.0001)  % Convergence criterion
   % disp(['The number of iteration : ' num2str(i)]);
   i=i+1;
   % The three nonlinear equations
   F = [ x(1)^2+x(2)^2-x(3)^2;                            
        x(1)^2-x(1)*x(2) + 4*x(3) ;
        2*x(1)+x(1)*x(2)+ x(3)^2];
   % Jacobian matrix
   J = [2*x(1) 2*x(2) -2*x(3); 2*x(1) -x(1) 4; 2 x(1) 2*x(3)];
   % Equation mismatch
   df =[-1 ;12 ;17] - F ;                 
   deltax =J\df;
   x = x+deltax;
   x1_print=x(1);
   x2_print=x(2);
   x3_print=x(3);
   fprintf('%d \t\t   %f \t\t   %f \t\t %f\n',i,x1_print,x2_print,x3_print);
end
