% Matlab M-file for Example 7.9: ex7_9.m
% *** Copyright 2016 by G. W. Chang *** %
% *** All rights reserved *** %
% Clean previous value
clc
clear all
% Initial value
syms x1 x2 
% Show f1(x1,x2),f2(x1,x2)
f1=4*x2*sin(x1)+0.6;            
f2=4*x2*x2-4*x2*cos(x1)+0.3;   
A=[f1;f2];
B=[x1,x2];
J=jacobian(A,B);
% Let x1=0 x2=1
Jnew=[4*cos(0) 4*sin(0);4*sin(0) 8*1-4*cos(0)];
% Calculate the first iteration of x1,x2
x1=0.0+(-0.15);      
x2=1+(-0.075);       
% Using first iteration of x1,x2 to caculate f1,f2
% Using the first iteration, now, x1=-0.15, x2=0.925
disp('Using the first iteration, now, x1=-0.15, x2=0.925')
f1new=-0.6-4*0.925*sin(-0.15);
f2new=-0.3-4*0.925*0.925+4*0.925*cos(-0.15);
delta_x=inv([3.658453 -0.597753;-0.552921 3.444916])*[f1new;f2new];
disp('Updating the Jacobian, we compute the new corrections')
disp(['delta_x=inv(Jacobian)*[f1new;f2new] = [ ',num2str(delta_x(1,1)),' , ',num2str(delta_x(2,1)),' ]'])
% Calculate new x1,x2
X1new=x1+delta_x(1,1);
X2new=x2+delta_x(2,1);
disp(['@X1new = x1+delta_x(1,1) = ',num2str(X1new)])
disp(['@X2new = x2+delta_x(2,1) = ',num2str(X2new)])
