% Matlab M-file of Example 8.3 (with Zbus Building Algorithm): ex8_3.m
% *** Copyright 2016 by G. W. Chang *** %
% *** All rights reserved *** %
% Clean previous value
clc
clear all
% Build bus impedance matrix by Zbus Building Algorithm
% Consider bus1 as bus3 and consider bus3 as bus1 
Zdata =  [0   1   0    0.3
          0   4   0    0.3
          3   2   0    0.125
          3   1   0    0.25
          3   4   0    0.4
          2   1   0    0.25
          2   4   0    0.2];

% Begin Z_bus Building Algorithm      
bus_number=max(max(Zdata(:,1),Zdata(:,2)));
size=length(Zdata);
bus_added=1;
bus_status=zeros(1,bus_number+1);

for n=1:size
    if(Zdata(n,1)==0)
        temp=Zdata(n,1);
        Zdata(n,1)=Zdata(n,2);
        Zdata(n,2)=temp;
    end
    if(Zdata(n,1)>Zdata(n,2) && Zdata(n,2)~=0)
        temp=Zdata(n,1);
        Zdata(n,1)=Zdata(n,2);
        Zdata(n,2)=temp;
    end
    if(Zdata(n,1)==1 && Zdata(n,2)==0)
        temp=Zdata(1,:);
        Zdata(1,:)=Zdata(n,:);
        Zdata(n,:)=temp;
    end
end

for n=1:bus_number
    for m=1:size
        if(Zdata(m,1)==n)
            bus_j=Zdata(m,1);
            bus_k=Zdata(m,2);
            Bus_j=0;
            Bus_k=0;
            for k=1:bus_number
                if(bus_status(1,k)==bus_j && bus_j~=0)
                    Bus_j=1;
                end
                if(bus_status(1,k)==bus_k && bus_k~=0)
                    Bus_k=1;
                end
            end
            
            if(bus_status(1,bus_added)==0 && bus_k==0 && Bus_j==0)    % This impedance is added between a new bus and reference
                bus_added=bus_added+1;
                bus_status(1,bus_added-1)=bus_j;
                if(bus_j==1)
                    Zbus(bus_j,bus_j)=Zdata(m,3)+j*Zdata(m,4);
                else
                    sz=length(Zbus);
                    Zbus(sz+1,sz+1)=Zdata(m,3)+j*Zdata(m,4);
                end
            end
            
            if(Bus_j==1 && Bus_k==0 && bus_k~=0)    % This impedance is added between a new bus and an existing bus
                bus_added=bus_added+1;
                bus_status(1,bus_added-1)=bus_k;
                sz=length(Zbus);
                
                for a=1:bus_number
                     if(bus_status(1,a)==bus_j)
                         col_j=a;
                     end
                end
                bus_j=col_j;
                 
                for var=1:sz
                    Zbus(sz+1,var)=Zbus(bus_j,var);
                    Zbus(var,sz+1)=Zbus(var,bus_j);
                end
                Zbus(sz+1,sz+1)=Zbus(bus_j,bus_j)+ Zdata(m,3)+ i*Zdata(m,4);
            end
            
            if(Bus_j==1 && Bus_k==0 && bus_k==0)    % This impedance is added between an existing bus and reference
                 sz=length(Zbus);
                 Zbus_t=Zbus;
                 
                 for a=1:bus_number
                     if(bus_status(1,a)==bus_j)
                         col_j=a;
                     end
                 end
                 bus_j=col_j;
                 
                 for var=1:sz
                    Zbus_t(sz+1,var)=Zbus_t(bus_j,var);
                    Zbus_t(var,sz+1)=Zbus_t(var,bus_j);
                 end
                 Zbus_t(sz+1,sz+1)=Zbus_t(bus_j,bus_j)+ Zdata(m,3)+ i*Zdata(m,4);
                 for var1=1:sz
                     for var2=1:sz
                         Zbus(var1,var2)=Zbus_t(var1,var2)- Zbus_t(var1,sz+1)*Zbus_t(sz+1,var2)/Zbus_t(sz+1,sz+1);    % Kron reduction
                     end
                 end
            end
            if(Bus_j==1 && Bus_k==1 && bus_k~=0)    % This impedance is added between two existing buses
                sz=length(Zbus);
                Zbus_t=Zbus;
                
                for a=1:bus_number
                     if(bus_status(1,a)==bus_j)
                         col_j=a;
                     end
                end
                for b=1:bus_number
                     if(bus_status(1,b)==bus_k)
                         col_k=b;
                     end
                end
                bus_j=col_j;
                bus_k=col_k;
                
                for var=1:sz
                    Zbus_t(sz+1,var)=Zbus_t(bus_j,var)-Zbus_t(bus_k,var);
                    Zbus_t(var,sz+1)=Zbus_t(var,bus_j)-Zbus_t(var,bus_k);
                end
                Zbus_t(sz+1,sz+1)=Zbus_t(bus_j,bus_j)+Zbus_t(bus_k,bus_k)-2*Zbus_t(bus_j,bus_k) + Zdata(m,3)+ i*Zdata(m,4);    % Kron reduction
                for var1=1:sz
                    for var2=1:sz
                        Zbus(var1,var2)=Zbus_t(var1,var2)- Zbus_t(var1,sz+1)*Zbus_t(sz+1,var2)/Zbus_t(sz+1,sz+1);
                    end
                end
            end
        end
    end
end

for p=1:bus_number
    for q=1:bus_number
        if(bus_status(1,q)==p)
            temp=Zbus(q,:);
            Zbus(q,:)=Zbus(p,:);
            Zbus(p,:)=temp;
            
            temp1=Zbus(:,q);
            Zbus(:,q)=Zbus(:,p);
            Zbus(:,p)=temp1;
            
            temp2=bus_status(1,p);
            bus_status(1,p)=bus_status(1,q);
            bus_status(1,q)=temp2;
        end
    end
end
% Change back to original
temp=Zbus(1,:);
Zbus(1,:)=Zbus(3,:);
Zbus(3,:)=temp;
temp1=Zbus(:,1);
Zbus(:,1)=Zbus(:,3);
Zbus(:,3)=temp1;

% End of Z_bus Building algorithm

Zbus

% Given base of bus
Zb1=0.125i;
Zb3=0.25i;
Zb4=0.2i;
% Caculate fault current
If=1./Zbus(2,2)
% Find the falut voltage
V1=1-Zbus(1,2)/Zbus(2,2)
V2=0 
V3=1-Zbus(3,2)/Zbus(2,2) 
V4=1-Zbus(4,2)/Zbus(2,2)
% Caculate current form BUS3 to BUS1
I31=(V3-V1)/0.25i
%Find current contrbuted by each BUS to BUS2
I_contribution_from_bus_1=V1/Zb1
I_contribution_from_bus_3=V3/Zb3
I_contribution_from_bus_4=V4/Zb4
