% Matlab M-file of Example 8.7: ex8_7.m
% *** Copyright 2016 by G. W. Chang *** %
% *** All rights reserved *** %
% Clean previous value
clc
clear all
% Initial values
St=25*10^6; %VA
VH=13.8*10^3;
VL=6.9*10^3;%V
Xg=0.15;%subtransient reactance of generator
Xm=0.2;%subtransient reactance of motor
Xt=0.1;%subtransient reactance of transformer
Sbase_motor=5*10^6; %VA
Vbase_motor=6.9*10^3; %V
Vf=1;
% Solution 
% (a) the subtransient current in the fault
disp('(a) The subtransient current in the fault')
Xm_new=Xm*St/Sbase_motor;
Zf=j*1/8;
If_pu=Vf/Zf;
If_pu_mag=abs(If_pu);                              %Convert radian to degree
If_pu_ang=angle(If_pu)*180/pi;
disp(['  If_pu = Vf/Zf = ',num2str(If_pu_mag),'',num2str(If_pu_ang),' pu']);
Ibase=St/(sqrt(3)*VL);
If=abs(If_pu)*Ibase;
disp(['  If=|If_pu|*Ibase = ',num2str(If),' A'])
disp([' The subtransient current in the fault is ',num2str(If),' A'])
% (b) the subtransient current in breaker A
disp('(b) The subtransient current in breaker A')
% The generator contributes a current
If_g=If_pu*(Xg+Xt)/0.5;
If_g_mag=abs(If_g);                              %Convert radian to degree
If_g_ang=angle(If_g)*180/pi;
disp(['  If_g = If_pu*(Xg+Xt)/0.5 = ',num2str(If_g_mag),'',num2str(If_g_ang),' pu']);
% Each motor contributes 25% of the remaining fault current
If_A_pu=If_g+3*If_g/4;
If_A_pu_mag=abs(If_A_pu);                              %Convert radian to degree
If_A_pu_ang=angle(If_A_pu)*180/pi;
disp(['  If_A_pu = If_g+3*If_g/4 = ',num2str(If_A_pu_mag),'',num2str(If_A_pu_ang),' pu']);
If_A=abs(If_A_pu)*Ibase;
disp(['  If_A = |If_A_pu|*Ibase = ',num2str(If_A),' A']);
disp([' The subtransient current in breaker A is ',num2str(If_A),' A'])
% (c) the symmetrical short-circuit interrupting current
% replace the subtransient reactance of j1.0 by the transient reactance of j1.5 in the motor circuits
Zf_m=1.5/4;
Zth=j*Zf_m*(Xg+Xt)/(Zf_m+(Xg+Xt));
%The generator contributes a current
If_g_sym=Vf/Zth*Zf_m/(Zf_m+(Xg+Xt));
If_g_sym_mag=abs(If_g_sym);                              %Convert radian to degree
If_g_sym_ang=angle(If_g_sym)*180/pi;
disp(['  If_g_sym = Vf/Zth*Zf_m/(Zf_m+(Xg+Xt)) = ',num2str(If_g_sym_mag),'',num2str(If_g_sym_ang),' pu']);
%Each motor contributes a current
If_m_sym=0.25*Vf/Zth*(Xg+Xt)/(Zf_m+(Xg+Xt));
If_m_sym_mag=abs(If_m_sym);                              %Convert radian to degree
If_m_sym_ang=angle(If_m_sym)*180/pi;
disp(['  If_m_sym = 0.25*Vf/Zth*(Xg+Xt)/(Zf_m+(Xg+Xt)) = ',num2str(If_m_sym_mag),'',num2str(If_m_sym_ang),' pu']);
% The symmetrical short-circuit current
If_sym=(If_g_sym+If_m_sym*3)*Ibase;
disp(['  If_sym = (If_g_sym+If_m_sym*3)*Ibase = ',num2str(If_sym),' A']);
disp([' The symmetrical short-circuit interrupting current is ',num2str(abs(If_sym)),' A'])
