% Matlab M-file of Example 8.8: ex8_8.m
% *** Copyright 2016 by G. W. Chang *** %
% *** All rights reserved *** %
% Clean previous value
clc
clear all
% Initial values
% Ybus has the triangular factors
L_m=[-j*10    0     0;
      j*1  -j*7.9   0; 
      j*5   j*3.5 -j*3.94937];
U_m=[  1     -0.1  -0.5;
       0       1   -0.44304;
       0       0      1     ];
Vf=1;
Zline_13=j*0.2;
% Solution 
syms x1 x2 x3
eq1=L_m(1,1)*x1;
eq2=L_m(2,1)*x1+L_m(2,2)*x2;
eq3=L_m(3,1)*x1+L_m(3,2)*x2+L_m(3,3)*x3-1;
[x1,x2,x3]=solve(eq1,eq2,eq3,'x1','x2','x3');
x3_doub=double(x3);
syms Z13 Z23 Z33
eq1_U=U_m(1,1)*Z13+U_m(1,2)*Z23+U_m(1,3)*Z33;
eq2_U=U_m(2,2)*Z23+U_m(2,3)*Z33;
eq3_U=U_m(3,3)*Z33-double(x3);
[Z13,Z23,Z33]=solve(eq1_U,eq2_U,eq3_U,'Z13','Z23','Z33');
Z13_doub=double(Z13);
Z23_doub=double(Z23);
Z33_doub=double(Z33);
% (a)the subtransient current in the fault is
Ifa=Vf/Z33_doub
Ifa_mag=abs(Ifa);
Ifa_ang=(angle(Ifa))*180/pi;
disp([' Ifa = Vf/Z33_doub =',num2str(Ifa_mag),'',num2str(Ifa_ang),' per unit'])
disp(['The subtransient current in the fault is ',num2str(Ifa_mag),'',num2str(Ifa_ang),' per unit'])
% (b) current in line 1-2
I13=-Vf/Zline_13*(Z13_doub-Z33_doub)/Z33_doub;
I13_mag=abs(I13);
I13_ang=(angle(I13))*180/pi;
disp([' I13 = -Vf/Zline_13*(Z13_doub-Z33_doub)/Z33_doub = ',num2str(I13_mag),'',num2str(I13_ang),' per unit'])
disp(['Current in line 1-3 is ',num2str(I13_mag),'',num2str(I13_ang),' per unit'])
% (c) During the fault the voltage at bus 2
V2=Vf*(1-Z23_doub/Z33_doub);
disp([' V2=Vf*(1-Z23_doub/Z33_doub = ',num2str(V2),' per unit'])
disp(['During the fault the voltage at bus 2 is ',num2str(V2),' per unit'])
