% M-file for Example 9.2: ex9_2.m
% *** Copyright 2016 by G. W. Chang *** %
% *** All rights reserved *** %
clc
clear all
Vab_abs=1840; Vbc_abs=2760; Vca_abs=2300; %V
Vbase=2300; Sbase=500; %kVA
%Calculate voltage in pu
Vab_abs_pu=Vab_abs/Vbase; Vbc_abs_pu=Vbc_abs/Vbase; Vca_abs_pu=Vca_abs/Vbase;
SHOW1=sprintf('abs(Voltage) in per unit , Vbase=2300V ,so |Vab|=%d ,|Vbc|=%d ,|Vca|=%d',Vab_abs_pu,Vbc_abs_pu,Vca_abs_pu);
disp(SHOW1);
%Assuming an angle of 180 (deg.) for Vc and apply the law of cosine
DEG_A=acosd((Vbc_abs_pu^2-Vab_abs_pu^2-Vca_abs_pu^2)/(-2*Vab_abs_pu*Vca_abs_pu)); 
DEG_B=-acosd((Vab_abs_pu^2-Vbc_abs_pu^2-Vca_abs_pu^2)/(-2*Vbc_abs_pu*Vca_abs_pu));
DEG_C=180;
%Line voltage
Vab=Vab_abs_pu*exp(DEG_A*(pi/180)*i); 
Vbc=Vbc_abs_pu*exp(DEG_B*(pi/180)*i);
Vca=Vca_abs_pu*exp(DEG_C*(pi/180)*i); 
a=1*exp(120*(pi/180)*i);
%Find symmetrical components
disp('Symmetrical components of voltage:')
Vab0=round((1/3)*(Vab+Vbc+Vca)); % pu
Vab0_mag=abs(Vab0);    Vab0_ang=angle(Vab0)*180/pi;
disp([' Vab0 = round((1/3)*(Vab+Vbc+Vca)) = ',num2str(Vab0_mag),'',num2str(Vab0_ang),' per unit']);
Vab1=(1/3)*(Vab+a*Vbc+a^2*Vca); % pu
Vab1_mag=abs(Vab1);    Vab1_ang=angle(Vab1)*180/pi;
disp([' Vab1 = (1/3)*(Vab+a*Vbc+a^2*Vca) = ',num2str(Vab1_mag),'',num2str(Vab1_ang),' per unit']);
Vab2=(1/3)*(Vab+a^2*Vbc+a*Vca); % pu
Vab2_mag=abs(Vab2);    Vab2_ang=angle(Vab2)*180/pi;
disp([' Vab2 = (1/3)*(Vab+a^2*Vbc+a*Vca) = ',num2str(Vab2_mag),'',num2str(Vab2_ang),' per unit']);
disp('Phasor parts:')
Van0=Vab0; %pu
Van0_mag=abs(Van0);    Van0_ang=angle(Van0)*180/pi;
disp([' Van0 = Vab0 = ',num2str(Van0_mag),'',num2str(Van0_ang),' per unit']);
Van1=Vab1*exp(-30*(pi/180)*i); % pu
Van1_mag=abs(Van1);    Van1_ang=angle(Van1)*180/pi;
disp([' Van1 = Vab1*exp(-30*(pi/180)*i) = ',num2str(Van1_mag),'',num2str(Van1_ang),' per unit']);
Van2=Vab2*exp(30*(pi/180)*i); % pu
Van2_mag=abs(Van2);    Van2_ang=angle(Van2)*180/pi;
disp([' Van2 = Vab2*exp(30*(pi/180)*i) = ',num2str(Van2_mag),'',num2str(Van2_ang),' per unit']);
disp('Since each resistor has an impedance of 1.0 per unit:')
Ia0=Van0/1;  Ia1=Van1/1;  Ia2=Van2/1; % pu
disp([' Ia0 = Van0/1 = ',num2str(Van0_mag),'',num2str(Van0_ang),' per unit']);
disp([' Ia1 = Van1/1 = ',num2str(Van1_mag),'',num2str(Van1_ang),' per unit']);
disp([' Ia2 = Van2/1 = ',num2str(Van2_mag),'',num2str(Van2_ang),' per unit']);