% Matlab M-file of Example 9.5: ex9_5.m
% *** Copyright 2016 by G. W. Chang *** %
% *** All rights reserved *** %
% Clean previous value
clc
clear all
% Initial values
Van_left=182+70i;%kV
Vbn_left=72.24-32.62i;%kV
Vcn_left=-170.24+88.62i;%kV
Van_right=154+28i;%kV
Vbn_right=44.24-74.62i;%kV
Vcn_right=-198.24+46.62i;%kV
Zaa=60i;
Zab=20i;
Znn=80i;
Zan=30i;
a=cosd(120)+j*sind(120);
A=[1                    1                         1;
   1          cosd(240)+j*sind(240)     cosd(120)+j*sind(120);
   1          cosd(120)+j*sind(120)     cosd(240)+j*sind(240);];

% Solution
Z0=Zaa+2*Zab+3*Znn-6*Zan;
Z1=Zaa-Zab;
Vaa_012=inv(A)*[Van_left-Van_right;Vbn_left-Vbn_right;Vcn_left-Vcn_right;];
Vaa=Vaa_012(1,1)+Vaa_012(2,1)+Vaa_012(3,1);
Vbb=Vaa_012(1,1)+a^2*Vaa_012(2,1)+a*Vaa_012(3,1);
Vcc=Vaa_012(1,1)+a*Vaa_012(2,1)+a^2*Vaa_012(3,1);
Ia_0=Vaa_012(1,1)/Z0;
Ia_1=Vaa_012(2,1)/Z0;
Ia_2=Vaa_012(3,1)/Z0;
Zs=Zaa+Znn-2*Zan;
Zm=Zab+Znn-2*Zan;
Z_mutual=[Zs Zm Zm;
          Zm Zs Zm;
          Zm Zm Zs];
disp('Line currents Ia, Ib, and Ic using symmetrical components')
V_matrix=[Vaa;Vbb;Vcc];
I_matrix=inv(Z_mutual)*V_matrix*1000
Ia_mag=abs(I_matrix(1));                              %Convert radian to degree
Ia_ang=angle(I_matrix(1))*180/pi;
Ib_mag=abs(I_matrix(2));                              %Convert radian to degree
Ib_ang=angle(I_matrix(2))*180/pi;
Ic_mag=abs(I_matrix(3));                              %Convert radian to degree
Ic_ang=angle(I_matrix(3))*180/pi;
disp(['[Ia,Ib,Ic]=inv(Z_mutual)*V_matrix*1000'])
disp([' Ia = ',num2str(Ia_mag),'',num2str(Ia_ang),' A']);
disp([' Ib = ',num2str(Ib_mag),'',num2str(Ib_ang),' A']);
disp([' Ic = ',num2str(Ic_mag),'',num2str(Ic_ang),' A']);
      
      

