% Matlab M-file for Example 9.6 : ex9_6.m
% *** Copyright 2016 by G. W. Chang *** %
% *** All rights reserved *** %
% Clean previous value
clc
clear all
%Initial value
Va=0;
Vb=1.013*exp(-102.25*(pi/180)*i);
Vc=1.013*exp(102.25*(pi/180)*i);
a=1*exp(120*(pi/180)*i);
A=[1 1 1;1 a^2 a;1 a a^2];
Z0=0.1i; %pu
Z1=0.25i;
Z2=0.35i; 
Ean=1; %pu
Sbase=20000; %kVA
Vbase=13.8; %kV
%Caculate Va_sequence ,in pu
Va_sequence=inv(A)*[Va;Vb;Vc]
Va0=Va_sequence(1);
Va1=Va_sequence(2);
Va2=Va_sequence(3);
%Caculate sequence current ,in pu
Ia0=-Va0/Z0
Ia1=(Ean-Va1)/Z1
Ia2=-Va2/Z2
%Find fault current ,in pu
disp('Fault current (in per unit) into the ground:')
Ia=Ia0+Ia1+Ia2;
Ia_mag=abs(Ia);                              %Convert radian to degree
Ia_ang=angle(Ia)*180/pi;
Ibase=round(Sbase/(sqrt(3)*Vbase));
disp([' Ia_pu = Ia0+Ia1+Ia2 = ',num2str(Ia_mag),'',num2str(Ia_ang),' per unit']);
disp([' Ia = Ia_pu*Ibase = ',num2str(Ia_mag*Ibase),'',num2str(Ia_ang),' A'])
%Caculate line to line fault voltage 
Vab_pu=Va-Vb;
Vbc_pu=Vb-Vc;
Vca_pu=Vc-Va;
disp('line to line voltage due to fault,in kV:')
Vab=Vab_pu*Vbase/sqrt(3);
Vab_mag=abs(Vab);                              %Convert radian to degree
Vab_ang=angle(Vab)*180/pi;
Vbc=Vbc_pu*Vbase/sqrt(3);
Vbc_mag=abs(Vbc);                              %Convert radian to degree
Vbc_ang=angle(Vbc)*180/pi;
Vca=Vca_pu*Vbase/sqrt(3);
Vca_mag=abs(Vca);                              %Convert radian to degree
Vca_ang=angle(Vca)*180/pi;
disp([' Vab = Vab_pu*Vbase/sqrt(3) = ',num2str(Vab_mag),'',num2str(Vab_ang),' kV'])
disp([' Vbc = Vbc_pu*Vbase/sqrt(3) = ',num2str(Vbc_mag),'',num2str(Vbc_ang),' kV'])
disp([' Vca = Vca_pu*Vbase/sqrt(3) = ',num2str(Vca_mag),'',num2str(Vca_ang),' kV'])