% Matlab M-file for Example 9.7: ex9_7.m
% *** Copyright 2016 by G. W. Chang *** %
% *** All rights reserved *** %
% Clean previous value
clc
clear all
%Initial values obtained from example 9.2
Ia0=0;
Ia1=0.98587*exp(43.55*(pi/180)*i);
Ia2=0.23468*exp(250.25*(pi/180)*i);
Van0=0;
Van1=0.98587*exp(43.55*(pi/180)*i);
Van2=0.23468*exp(250.25*(pi/180)*i);
a=1*exp(120*(pi/180)*i);
%Transfer phase voltage from low_voltage Y-side to high_voltage delta-side
%Advancing the phase angle of the low-voltage positive-sequence voltage by
%30 deg.
%Delta-side voltage
VA0=Van0;
VA1=Van1*exp(30*(pi/180)*i);
VA2=Van2*exp(-30*(pi/180)*i);
VA=VA0+VA1+VA2; %pu
VA_Mag=abs(VA);
VA_Deg=rad2deg(angle(VA));
VB0=VA0;
VB1=a^2*VA1;
VB2=a*VA2;
VB=VB0+VB1+VB2; %pu
VB_Mag=abs(VB);
VB_Deg=rad2deg(angle(VB));
VC0=VA0;
VC1=a*VA1;
VC2=a^2*VA2;
VC=VC0+VC1+VC2; %pu
VC_Mag=abs(VC);
VC_Deg=rad2deg(angle(VC));
%Calculate line to line voltage
disp('line to line voltage in per unit:')
disp('in line-neutral voltage base:')
VAB_LN=VA-VB;
VAB_LN_Mag=abs(VAB_LN);
VAB_LN_Deg=rad2deg(angle(VAB_LN));
disp([' VAB_LN = VA-VB = ',num2str(VAB_LN_Mag),'',num2str(VAB_LN_Deg),' per unit'])
VBC_LN=VB-VC;
VBC_LN_Mag=abs(VBC_LN);
VBC_LN_Deg=rad2deg(angle(VBC_LN));
disp([' VBC_LN = VB-VC = ',num2str(VBC_LN_Mag),'',num2str(VBC_LN_Deg),' per unit'])
VCA_LN=VC-VA;
VCA_LN_Mag=abs(VCA_LN);
VCA_LN_Deg=rad2deg(angle(VCA_LN));
disp([' VCA_LN = VC-VA = ',num2str(VCA_LN_Mag),'',num2str(VCA_LN_Deg),' per unit'])
disp('in line-line voltage base:')
VAB_LL=(VA-VB)/sqrt(3);
VAB_LL_Mag=abs(VAB_LL);
VAB_LL_Deg=rad2deg(angle(VAB_LL));
disp([' VAB_LL = (VA-VB)/sqrt(3) = ',num2str(VAB_LL_Mag),'',num2str(VAB_LL_Deg),' per unit'])
VBC_LL=(VB-VC)/sqrt(3);
VBC_LL_Mag=abs(VBC_LL);
VBC_LL_Deg=rad2deg(angle(VBC_LL));
disp([' VBC_LL = (VB-VC)/sqrt(3) = ',num2str(VBC_LL_Mag),'',num2str(VBC_LL_Deg),' per unit'])
VCA_LL=(VC-VA)/sqrt(3);
VCA_LL_Mag=abs(VCA_LL);
VCA_LL_Deg=rad2deg(angle(VCA_LL));
disp([' VCA_LL = (VC-VA)/sqrt(3) = ',num2str(VCA_LL_Mag),'',num2str(VCA_LL_Deg),' per unit'])
disp('For the impedance is 1+0j pu , current in per unit:')
Ia=VA/1;
Ia_Mag=abs(Ia);
Ia_Deg=rad2deg(angle(Ia));
disp([' Ia = VA/1 = ',num2str(Ia_Mag),'',num2str(Ia_Deg),' per unit'])
Ib=VB/1;
Ib_Mag=abs(Ib);
Ib_Deg=rad2deg(angle(Ib));
disp([' Ib = VB/1 = ',num2str(Ib_Mag),'',num2str(Ib_Deg),' per unit'])
Ic=VC/1;
Ic_Mag=abs(Ic);
Ic_Deg=rad2deg(angle(Ic));
disp([' Ic = VC/1 = ',num2str(Ic_Mag),'',num2str(Ic_Deg),' per unit'])
