% Matlab M-file of Example 9.9: ex9_9.m
% *** Copyright 2016 by G. W. Chang *** %
% *** All rights reserved *** %
% Clean previous value
clc
clear all
% Initial values
% Get form Example 5.1
X0=0.05;
Sbase_new=300*10^6;%VA
Vbase_new=13.8*10^3;%V
Sbase_old=200*10^6;%VA
Sbase_old2=100*10^6;%VA
Vbase_old=13.2*10^3;%V
V_Generator=20*10^3;%V
% Transformer 1 zero-sequence impedance in per unit
Z_Tr1_0=0.0857i
% Transformer 2 zero-sequence impedance in per unit
Z_Tr2_0=0.0915i 
Z_geneator=0.4;
Z_motor=0.4;
Z_per_km=1.5; %ohm per km
% Get form Example 5.1
Length=64; %km
Zbase_line=176.3;%ohm
% Solution 
disp('Zero-sequence reactances of the generator and motors are')
X0_motor1=0.05*(Sbase_new/Sbase_old)*(Vbase_old/Vbase_new)^2;
X0_motor2=0.05*(Sbase_new/Sbase_old2)*(Vbase_old/Vbase_new)^2;
disp([' Generator: X0= ',num2str(X0),' per unit'])
disp([' Motor 1: X0= ',num2str(X0_motor1),' per unit'])
disp([' Motor 2: X0= ',num2str(X0_motor2),' per unit'])
Zbase_generator=V_Generator^2/Sbase_new;
Zbase_motor=Vbase_new^2/Sbase_new;
Zn_generator=3*Z_geneator/Zbase_generator;
disp(['In the impedance network of current limiter for the generator is ',num2str(Zn_generator),' per unit'])
Zn_motor=3*Z_motor/Zbase_motor;
disp(['In the impedance network for the motor is ',num2str(Zn_motor),' per unit'])
Z_line=Length*Z_per_km/Zbase_line;
disp(['In the impedance network for the transmission line is ',num2str(Z_line),' per unit'])
