% ******************************************** %
% *** Copyright 2016 by G. W. Chang *** %
% *********** All rights reserved *********** %
% ******************************************** %
function varargout = chp10ex1(varargin)

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @chp10ex1_OpeningFcn, ...
    'gui_OutputFcn',  @chp10ex1_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

function chp10ex1_OpeningFcn(hObject, eventdata, handles, varargin)

handles.output = hObject;
set(handles.axes1,'Units','pixels');
POSITION = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized');
assignin('base','position',POSITION);
imshow('ex10_1_1.png','parent',handles.axes1)
% Update handles structure
guidata(hObject, handles);
assignin('base','check',0);

function varargout = chp10ex1_OutputFcn(hObject, eventdata, handles)

varargout{1} = handles.output;

function slider1_Callback(hObject, eventdata, handles)
position = evalin ('base','position') ;
b = get(handles.slider1, 'Value');
set(handles.axes1, 'xlim',  [0.5  position(3)] + b );

function slider1_CreateFcn(hObject, eventdata, handles)
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end
function slider2_Callback(hObject, eventdata, handles)
position = evalin ('base','position') ;
a = get(handles.slider2, 'Value');
set(handles.axes1, 'ylim',  [0.5  position(4)] - a );

function slider2_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

function pushbutton1_Callback(hObject, eventdata, handles)
set(handles.axes2,'Units','pixels')
position2 = get(handles.axes2,'Position');
set(handles.axes2,'Units','normalized')
assignin('base','position2',position2);
a2 = imread('ex10_1_2.png');
b2 = imresize(a2,[position2(4) position2(3)],'bicubic');
c2 = rgb2gray(b2);
c2 = imadjust(c2,[ ],[ ],3);
imshow(c2,'parent',handles.axes2)

assignin('base','check',1);
set(handles.listbox1,'string',{
    'The given per-unit impedance values correspond to the chosen base,'
    'and so they can be used directly to form the sequence networks. Figure 10.6(a) '
    'shows the positive-sequence network, which is identical to the negative-sequence'
    'network when the emfs are short-circuited; Fig. 10.6(b) shows the zero-sequence '
    'network with reactance 3X_n = 0.15 per unit in the neutral connection of each '
    'machine. Note that each transformer is assigned an internal nodeXbus (5) for '
    'transformer T1 and bus (6) for transformer T_2. These internal nodes do not have an'
    'active role in the analysis of the system. In order to apply the Z_bus building '
    'algorithm, which is particularly simple in this example, let us label the zero-'
    'sequence branches from 1 to 7 as shown.'
    ''
    'Step 1'
    'Add branch 1 to the reference node'
    '[j0.19]'
    ''
    'Step 2'
    'Add branch 2 to the reference node'
    '[j0.19, 0;'
    '  0, j0.19]'
    '   '
    'Step 3'
    'Add branch 3 between buses (5) and (2)'
    '[j0.19, 0, 0;'
    '  0, j0.04, j0.04;'
    '  0, j0.04, j0.08]'
    ''
    'Step 4'
    'Add branch 4 between buses (2) and (3)'
    '[j0.19, 0, 0, 0;'
    '  0, j0.04, j0.04, j0.04;'
    '  0, j0.04, j0.08, j0.08;'
    '  0, j0.04, j0.08, j0.58]'
    ''
    'Step 5'
    'Add branch 5 between buses (3) and (6)'
    '[j0.19, 0, 0, 0, 0;'
    '  0, j0.04, j0.04, j0.04, j0.04;'
    '  0, j0.04, j0.08, j0.08, j0.08;'
    '  0, j0.04, j0.08, j0.58, j0.58; '
    '  0, j0.04, j0.08, j0.58, j0.66]'
    ''
    'Step 6'
    'Add branch 6 from bus (4) to the reference'
    '[j0.19, 0, 0, 0, 0, 0;'
    '  0, j0.04, j0.04, j0.04, j0.04, 0;'
    '  0, j0.04, j0.08, j0.08, j0.08, 0;'
    '  0, j0.04, j0.08, j0.58, j0.58, 0; '
    '  0, j0.04, j0.08, j0.58, j0.66, 0;'
    '  0, 0, 0, 0, 0, j0.19]'
    ''
    'Buses (5) and (6) are the fictitious internal nodes of the transformers which'
    'facilitate computer application of the Z_bus building algorithm. We have not shown'
    'calculations for the very high impedance branches representing the open circuits.'
    'Let us remove the rows and columns for buses (5) and (6) from the matrix to obtain'
    'the effective working matrix'
    'Z_bus(0) = [j0.19, 0, 0, 0;'
    '                     0, j0.08, j0.08, 0;'
    '                     0, j0.08, j0.58, 0;'
    '                     0, 0, 0, j0.19]'
    'The zeros in Z_bus(0) show that zero-sequence current injected into bus (1) or bus (4)'
    'of Fig. 10.6(b) cannot cause voltages at the other buses because of the open'
    'circuits introduced by the G-Y transformers. Note also that the j0.08 per-unit'
    'reactance in series with the open circuit between buses (6) and (4) does not affect'
    'Z_bus(0) since it cannot carry current.'
    'By applying the Zbus building algorithm to the positive- and negative-'
    'sequence networks in a similar manner, we obtain'
    'Z_bus(1) = Z_bus(2) = [j0.1437, j0.1211, j0.0789, j0.0563;'
    '                                        j0.1211, j0.1696, j0.1104, j0.0789;'
    '                                        j0.0789, j0.1104, j0.1696, j0.1211;'
    '                                        j0.0563, j0.0789, j0.1211, j0.1437]'
    })

function pushbutton2_Callback(hObject, eventdata, handles)
close(gcf)
chapter10

function pushbutton3_Callback(hObject, eventdata, handles)

set(handles.listbox1,'string',{
    '% Using the Zbus building algorithm to find the zero-sequence Zbus'
    'clc'
    'clear all'
    'format short g;'
    'data =  [1 0 0 j*0.19;'
    '         5 0 0 j*0.04;'
    '         5 2 0 j*0.04;'
    '         2 3 0 j*0.5;'
    '         3 6 0 j*0.08;'
    '         4 0 0 j*0.19;];'
    ''
    'temp=zeros(1,length(data(1,:)));'
    'bus_num= max(max(data(:,1),data(:,2)));'
    'status=zeros(1,bus_num+1);'
    'status_order=zeros(1,4);'
    'status(bus_num+1)=-1;'
    'bus=0;'
    'bus_temp=0;'
    'save=1;'
    'for i=1:length(data(:,1))'
    '  x=data(i,1); y=data(i,2);'
    '  col1=check(x,bus_num,status);'
    '  col2=check(y,bus_num,status);'
    '  CASE= col1+col2;'
    '  '
    '  switch CASE'
    '      case 0 '
    '         bus=bus;'
    '         bus_temp=bus+1;'
    '         if (y==0)'
    '              disp(''case 3'')'
    '              r1=find_index(x,status_order);'
    '              zbus0(bus_temp,:)=zbus0(r1,:)'
    '              zbus0(:,bus_temp)=zbus0(:,r1)'
    '              zbus0(bus_temp,bus_temp)=zbus0(r1,r1)+data(i,4);   '
    '              zbus0= Kron_reduction(zbus0);'
    '         else    '
    '              disp(''case 4'')'
    '              r1=find_index(x,status_order);'
    '              r2=find_index(y,status_order);'
    '              for v=1:bus'
    '                  zbus0(bus_temp,v)= zbus0(r1,v)-zbus0(r2,v);'
    '                  zbus0(v,bus_temp)= zbus0(v,r1)-zbus0(v,r2);'
    '              end'
    '              zbus0(bus_temp,bus_temp)= zbus0(r1,r1)+zbus0(r2,r2)-2*zbus0(r2,r1)+data(i,4);'
    '              zbus0= Kron_reduction(zbus0);'
    '         end'
    '      case 1'
    '          bus=bus+1;'
    '          bus_temp=bus;       '
    '          if (y==0)'
    '              disp(''case 1*'')'
    '              zbus0(bus,:)=0;'
    '              zbus0(:,bus)=0;'
    '              zbus0(bus,bus)=data(i,4);'
    '          else'
    '              disp(''case 2'');'
    '              if(col1==1) % x is the new bus and vice versa'
    '                  old_bus=find_index(y,status_order);'
    '              else % y is the new bus and vice versa'
    '                  old_bus=find_index(x,status_order);'
    '              end'
    '              zbus0(bus,:)= zbus0(old_bus,:);'
    '              zbus0(:,bus)=zbus0(:,old_bus);'
    '              zbus0(bus,bus)=zbus0(old_bus,old_bus)+data(i,4);'
    '          end'
    '      case 2  '
    '          disp(''case 1'')'
    '          bus=bus+1;'
    '          bus_temp=bus;'
    '          zbus0(bus,:)=0;'
    '          zbus0(:,bus)=0;'
    '          zbus0(bus,bus)= data(i,4);'
    '          '
    '  end % end switch'
    '  '
    '  if (col1==1) && (x~=0)'
    '      status_order(save)= x;'
    '      save=save+1;'
    '  end'
    '  if (col2==1) && (y~=0)'
    '      status_order(save)= y;'
    '      save=save+1;'
    '  end'
    '  '
    '  %save_status'
    '  if (x==0)'
    '      status(bus_num+1)=x;'
    '  else'
    '    status(x)=x;'
    '  end'
    ' '
    '  if (y==0)'
    '      status(bus_num+1)=y;'
    '  else'
    '    status(y)=y;'
    '  end'
    ''
    'end'
    'status_order;'
    '% remove raw & column 5,6'
    'zbus_temp1=zbus0;'
    'zbus0=zeros(4,4);'
    'zbus_temp2(1,:)=zbus_temp1(1,:);'
    'zbus_temp2(2,:)=zbus_temp1(3,:);'
    'zbus_temp2(3,:)=zbus_temp1(4,:);'
    'zbus_temp2(4,:)=zbus_temp1(6,:);'
    ''
    'zbus0(:,1)= zbus_temp2(:,1);'
    'zbus0(:,2)= zbus_temp2(:,3);'
    'zbus0(:,3)= zbus_temp2(:,4);'
    'zbus0(:,4)= zbus_temp2(:,6);    '
    ''
    '% Output zbus'
    ''
    'zbus0'
    ''
    'data=[1 0 0 j*0.2;'
    '      1 2 0 j*0.08;'
    '      2 3 0 j*0.15;'
    '      3 4 0 j*0.08;'
    '      4 0 0 j*0.2;];'
    'temp=zeros(1,length(data(1,:)));'
    'bus_num= max(max(data(:,1),data(:,2)));'
    'status=zeros(1,bus_num+1);'
    'status_order=zeros(1,4);'
    'status(bus_num+1)=-1;'
    'bus=0;'
    'bus_temp=0;'
    'save=1;'
    'for i=1:length(data(:,1))'
    '  x=data(i,1); y=data(i,2);'
    '  col1=check(x,bus_num,status);'
    '  col2=check(y,bus_num,status);'
    '  CASE= col1+col2;'
    '  '
    '  switch CASE'
    '      case 0 '
    '         bus=bus;'
    '         bus_temp=bus+1;'
    '         if (x==0)||(y==0)'
    '             disp(''case 3'')'
    '             if (x==0)'
    '                  r1=find_index(y,status_order);'
    '             else'
    '                  r1=find_index(x,status_order);'
    '             end'
    '              zbus(bus_temp,:)=zbus(r1,:);'
    '              zbus(:,bus_temp)=zbus(:,r1);      '
    '              zbus(bus_temp,bus_temp)=zbus(r1,r1)+data(i,4); '
    '              zbus= Kron_reduction(zbus);'
    '         else    '
    '              disp(''case 4'')'
    '              r1=find_index(x,status_order);'
    '              r2=find_index(y,status_order);'
    '              for v=1:bus'
    '                  zbus(bus_temp,v)= zbus(r1,v)-zbus(r2,v);'
    '                  zbus(v,bus_temp)= zbus(v,r1)-zbus(v,r2);'
    '              end'
    '              zbus(bus_temp,bus_temp)= zbus(r1,r1)+zbus(r2,r2)-2*zbus(r2,r1)+data(i,4);'
    '              zbus= Kron_reduction(zbus);'
    '         end'
    '      case 1;'
    '          bus=bus+1;'
    '          bus_temp=bus;     '
    '          if (y==0)||(x==0)'
    '              disp(''case 1'')'
    '              if (x==0)'
    '                    zbus(bus,:)=0;'
    '                    zbus(:,bus)=0;'
    '                    zbus(bus,bus)=data(i,4);'
    '              else'
    '                    zbus(bus,:)=0;'
    '                    zbus(:,bus)=0;'
    '                    zbus(bus,bus)=data(i,4);'
    '              end'
    ''
    '          else'
    '              disp(''case 2'');'
    '              if(col1==1) % x is the new bus and vice versa'
    '                  old_bus=find_index(y,status_order);'
    '              else % y is the new bus and vice versa'
    '                  old_bus=find_index(x,status_order);'
    '              end'
    '              zbus(bus,:)= zbus(old_bus,:);'
    '              zbus(:,bus)=zbus(:,old_bus);'
    '              zbus(bus,bus)=zbus(old_bus,old_bus)+data(i,4);'
    '          end'
    '      case 2;  '
    '          disp(''case 1'')'
    '          bus=bus+1;'
    '          bus_temp=bus;'
    '          zbus(bus,:)=0;'
    '          zbus(:,bus)=0;'
    '          zbus(bus,bus)= data(i,4);'
    '          '
    '  end % end switch'
    '  '
    '  if (col1==1) && (x~=0)'
    '      status_order(save)= x;'
    '      save=save+1;'
    '  end'
    '  if (col2==1) && (y~=0)'
    '      status_order(save)= y;'
    '      save=save+1;'
    '  end'
    '  '
    '  %save_status'
    '  if (x==0)'
    '      status(bus_num+1)=x;'
    '  else'
    '    status(x)=x;'
    '  end'
    ' '
    '  if (y==0)'
    '      status(bus_num+1)=y;'
    '  else'
    '    status(y)=y;'
    '  end'
    'end'
    ''
    'zbus_temp=zbus;'
    'for i=1:bus'
    '    t(i,:)=zbus_temp(status_order(i),:);'
    'end'
    ''
    'for i=1:bus'
    '    zbus(:,i)=t(:,status_order(i));'
    'end'
    ''
    '% Output positive- and negative-sequence impedance networjs Zbus'
    ''
    'zbus'
    })

function listbox1_Callback(hObject, eventdata, handles)

function listbox1_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function uipanel1_ResizeFcn(hObject, eventdata, handles)
set(handles.axes1,'Units','pixels')
position = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized')
assignin('base','position',position);
a = imread('ex10_1_1.png');
b = imresize(a,[position(4) position(3)],'bicubic');
c = rgb2gray(b);
c = imadjust(c,[ ],[ ],3);
axes(handles.axes1);
imshow(c);

set(handles.slider2,'Units','pixels');
set(handles.slider2,'Min',-560);
set(handles.slider2,'Units','normalized');
 
% set(handles.axes1,'Units','pixels');
% set(handles.axes1,'Position',[129.111595466434,-471.296577946768,913.938971229294,813.034220532319]);
% set(handles.axes1,'Units','normalized');

check = evalin ('base','check') ;
if check == 1
    set(handles.axes2,'Units','pixels')
    position3 = get(handles.axes2,'Position');
    set(handles.axes2,'Units','normalized')
    assignin('base','position3',position3);
    a2 = imread('ex10_1_2.png');
    b2 = imresize(a2,[position3(4) position3(3)],'bicubic');
    c2 = rgb2gray(b2);
    c2 = imadjust(c2,[ ],[ ],3);
    axes(handles.axes2);
    imshow(c2);
end


function pushbutton5_Callback(hObject, eventdata, handles)
set(handles.listbox1,'string',{
     '%----------check----------%'
    '% 0 for existing bus'
    '% 1 for new bus'
    'function t = check(k,n,status)'
    ' if(k==0)'
    '     if( k==status(1,n+1))'
    '         t=0;'
    '     else'
    '         t=1;'
    '     end'
    ' else'
    '    if(k==status(1,k))'
    '        t=0; '
    '    else'
    '        t=1; '
    '    end'
    ' end'
    'end'
    '%-------------------------%'
    })
function pushbutton8_Callback(hObject, eventdata, handles)
set(handles.listbox1,'string',{ 
'%--------find_index-------%'
    'function index=findindex(value,array)'
    '    for ind=1:length(array)'
    '        if value==array(ind)'
    '            index=ind;'
    '        end'
    '    end'
    'end'
    '%-------------------------%'
    })
function pushbutton12_Callback(hObject, eventdata, handles)
set(handles.listbox1,'string',{
    '%------Kron_reduction-----%'
    'function zbus= Kron_reduction(zbus)'
    '    sz=size(zbus); pivot=sz(1);'
    '    ztemp=zeros(pivot,pivot);'
    '    for m=1:pivot'
    '        for n=1:pivot'
    '            z(m,n)=zbus(m,n)-((zbus(m,pivot))*(zbus(pivot,n)))/(zbus(pivot,pivot)); '
    '        end'
    '    end'
    '    zbus=zeros(pivot-1,pivot-1);'
    '    % remove row of tempoary bus'
    '    for a=1:pivot-1'
    '        for b=1:pivot-1'
    '            zbus(a,b)=z(a,b);'
    '        end'
    '    end'
    'end'
    '%-------------------------%'
    })
