% ******************************************** %
% *** Copyright 2016 by G. W. Chang *** %
% *********** All rights reserved *********** %
% ******************************************** %
function varargout = chp12ex3(varargin)

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @chp2ex14_OpeningFcn, ...
    'gui_OutputFcn',  @chp2ex14_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

function chp2ex14_OpeningFcn(hObject, eventdata, handles, varargin)

handles.output = hObject;

axes(handles.axes1);
set(handles.axes1,'Units','pixels');
POSITION = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized');
assignin('base','position',POSITION);
imshow('ex12_3.png');
% Update handles structure
guidata(hObject, handles);

function varargout = chp2ex14_OutputFcn(hObject, eventdata, handles)

varargout{1} = handles.output;

function pushbutton1_Callback(hObject, eventdata, handles)
set(handles.text2, 'String',  {
    'The generation outputs of Unit 1 is 6.521739 MW'
    'The generation outputs of Unit 2 is 76.086957 MW'
    'The generation outputs of Unit 3 is 89.130435 MW'
    'The generation outputs of Unit 4 is 328.260870 MW'
    'Total fuel cost of the economic dispatch schedule is 1333.739130 $/hr'
    },'HorizontalAlignment','left');

function pushbutton2_Callback(hObject, eventdata, handles)
close(gcf)
chapter12
function popupmenu1_Callback(hObject, eventdata, handles)

function popupmenu1_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider1_Callback(hObject, eventdata, handles)
position = evalin ('base','position') ;
b = get(handles.slider1, 'Value');
set(handles.axes1, 'xlim',  [0.5  position(3)] + b );
function slider1_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function slider2_Callback(hObject, eventdata, handles)
position = evalin ('base','position') ;
a = get(handles.slider2, 'Value');
set(handles.axes1, 'ylim',  [0.5  position(4)] - a );

% --- Executes during object creation, after setting all properties.
function slider2_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



function text2_Callback(hObject, eventdata, handles)

function text2_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function pushbutton3_Callback(hObject, eventdata, handles)
set(handles.text2,'Style','listbox');
set(handles.text2, 'String',  {
'% M-file of Example 12.3: ex12_3.m'
'% Clean previous value'
'clc'
'clear all'
'% Initial values'
'PgT=500;'
'syms Pg1 Pg2 Pg3 Pg4'
'a1=0.012; b1=2.6; c1=25; % $/hour'
'f1=a1*Pg1^2+b1*Pg1+c1;'
'a2=0.003; b2=2.3; c2=12; % $/hour'
'f2=a2*Pg2^2+b2*Pg2+c2;'
'a3=0.002; b3=2.4; c3=10; % $/hour'
'f3=a3*Pg3^2+b3*Pg3+c3;'
'a4=0.001; b4=2.1; c4=50; % $/hour'
'f4=a4*Pg4^2+b4*Pg4+c4;'
'% Solution'
'df1= diff(f1,Pg1);'
'df2= diff(f2,Pg2);'
'df3= diff(f3,Pg3);'
'df3= diff(f4,Pg4);'
'aT=(1/(2*a1)+1/(2*a2)+1/(2*a3)+1/(2*a4))^-1;'
'bT=aT*((b1/(2*a1))+(b2/(2*a2))+(b3/(2*a3))+(b4/(2*a4)));'
'lambda=aT*PgT+bT %incremental fuel cost '
'Pg1=(lambda-b1)/(2*a1)'
'Pg2=(lambda-b2)/(2*a2)'
'Pg3=(lambda-b3)/(2*a3)'
'Pg4=(lambda-b4)/(2*a4)'
'Total_cost=eval(f1)+eval(f2)+eval(f3)+eval(f4)% $/hour total fuel cost' 
},'HorizontalAlignment','left');

function uipanel3_ResizeFcn(hObject, eventdata, handles)
set(handles.axes1,'Units','pixels');
position = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized');
position;
assignin('base','position',position);
a = imread('ex12_3.png');
b = imresize(a,[position(4) position(3)],'bicubic');
c = rgb2gray(b);
c = imadjust(c,[ ],[ ],2);
imshow(c);
