% ******************************************** %
% *** Copyright 2016 by G. W. Chang *** %
% *********** All rights reserved *********** %
% ******************************************** %
function varargout = chp12ex4(varargin)

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @chp2ex14_OpeningFcn, ...
    'gui_OutputFcn',  @chp2ex14_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

function chp2ex14_OpeningFcn(hObject, eventdata, handles, varargin)

handles.output = hObject;

axes(handles.axes1);
set(handles.axes1,'Units','pixels');
POSITION = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized');
assignin('base','position',POSITION);
imshow('ex12_4.png');
% Update handles structure
guidata(hObject, handles);

function varargout = chp2ex14_OutputFcn(hObject, eventdata, handles)

varargout{1} = handles.output;

function pushbutton1_Callback(hObject, eventdata, handles)
set(handles.text2, 'String',  {
    'Uses Eqs. (12.11),(12.9) and (12.3),we have'
    'NewLambda = 2.8880'
    'mun_lambda1 = 3.3200'
    'max_lambda4 = 2.6000'
    'The incremental fuel cost of Units 2 and 3 to achieve the economic dispatch schedule is 2.888 $/WMh'
    'Also, Unit 1 is at its minimum generation limit and Unit 4 is at its maximum generation limit.'
    'Then, the minimum lambda of Unit 1 is 3.32 $/MWh'
    'the maximum lambda of Unit 4 is 2.60 $/MWh'
    'The generation outputs of Unit 1 is 30 MW'
    'The generation outputs of Unit 2 is 98 MW'
    'The generation outputs of Unit 3 is 122 MW'
    'The generation outputs of Unit 4 is 250 MW'
    'Total fuel cost of the economic dispatch schedule is 1350.08 $/hr'
    },'HorizontalAlignment','left');

function pushbutton2_Callback(hObject, eventdata, handles)
close(gcf)
chapter12
function popupmenu1_Callback(hObject, eventdata, handles)

function popupmenu1_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider1_Callback(hObject, eventdata, handles)
position = evalin ('base','position') ;
b = get(handles.slider1, 'Value');
set(handles.axes1, 'xlim',  [0.5  position(3)] + b );
function slider1_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function slider2_Callback(hObject, eventdata, handles)
position = evalin ('base','position') ;
a = get(handles.slider2, 'Value');
set(handles.axes1, 'ylim',  [0.5  position(4)] - a );

% --- Executes during object creation, after setting all properties.
function slider2_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



function text2_Callback(hObject, eventdata, handles)

function text2_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function pushbutton3_Callback(hObject, eventdata, handles)
set(handles.text2,'Style','listbox');
set(handles.text2, 'String',  {
'% M-file of Example 12.4: ex12_4.m'
'% Clean previous value'
'clc'
'clear all'
'% Initial values'
'PgT=500;'
'syms Pg1 Pg2 Pg3 Pg4'
'a1=0.012; b1=2.6; c1=25; % $/hour'
'f1=a1*Pg1^2+b1*Pg1+c1;'
'a2=0.003; b2=2.3; c2=12; % $/hour'
'f2=a2*Pg2^2+b2*Pg2+c2;'
'a3=0.002; b3=2.4; c3=10; % $/hour'
'f3=a3*Pg3^2+b3*Pg3+c3;'
'a4=0.001; b4=2.1; c4=50; % $/hour'
'f4=a4*Pg4^2+b4*Pg4+c4;'
'Pg1_low_limit=30;%MW'
'Pg2_low_limit=40;%MW'
'Pg3_low_limit=60;%MW'
'Pg4_low_limit=80;%MW'
'Pg1_high_limit=160;%MW'
'Pg2_high_limit=130;%MW'
'Pg3_high_limit=190;%MW'
'Pg4_high_limit=250;%MW'
'% Solution'
'% Unit 1 must fix its output at the minimum generation of 30W'
'% Unit 4 must fix its output at the maximum generation of 250W'
'Pg1=30;'
'Pg4=250;'
'Pg2_plus_Pg3=PgT-(Pg1+Pg4);'
'aT=(1/(2*a2)+1/(2*a3))^-1;'
'bT=aT*((b2/(2*a2))+(b3/(2*a3)));'
'lambda=aT*Pg2_plus_Pg3+bT %incremental fuel cost' 
'Pg2=(lambda-b2)/(2*a2);'
'Pg3=(lambda-b3)/(2*a3);'
'lambda1_min=2*a1*Pg1_low_limit+b1;'
'lambda4_max=2*a4*Pg4_high_limit+b4;'
'% total fuel cost'
'F=eval(f1)+eval(f2)+eval(f3)+eval(f4)'
},'HorizontalAlignment','left');

function uipanel3_ResizeFcn(hObject, eventdata, handles)
set(handles.axes1,'Units','pixels');
position = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized');
position;
assignin('base','position',position);
a = imread('ex12_4.png');
b = imresize(a,[position(4) position(3)],'bicubic');
c = rgb2gray(b);
c = imadjust(c,[ ],[ ],2);
imshow(c);
