% ******************************************** %
% *** Copyright 2016 by G. W. Chang *** %
% *********** All rights reserved *********** %
% ******************************************** %
function varargout = chp2ex1(varargin)

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @chp2ex1_OpeningFcn, ...
                   'gui_OutputFcn',  @chp2ex1_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
function chp2ex1_OpeningFcn(hObject, eventdata, handles, varargin)

handles.output = hObject;
axes(handles.axes1)
imshow('ex2_1.png','parent',handles.axes1)
set(handles.axes1,'Units','pixels');
POSITION = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized');
assignin('base','position',POSITION);
guidata(hObject, handles);

function varargout = chp2ex1_OutputFcn(hObject, eventdata, handles) 

varargout{1} = handles.output;

function listbox1_Callback(hObject, eventdata, handles)

function listbox1_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function pushbutton1_Callback(hObject, eventdata, handles)
%Show the pitcure of answer
set(handles.axes2,'Units','pixels');   
position1 = get(handles.axes2,'Position');
set(handles.axes2,'Units','normalized');
assignin('base','position1',position1);
a1 = imread('ex2_1_2.png');
b1 = imresize(a1,[position1(4) position1(3)],'bicubic');
c1 = rgb2gray(b1);
c1= imadjust(c1,[ ],[ ],3);
imshow(c1,'parent',handles.axes2)
% M-file of Example 2.1: ex2_1.m
% Initial values
P=50000; %W
PF=0.8;  V=220;  PFnew=0.95;
f=60;                                        % system frequency
% Solution
theta=acosd(PF);                       %the angle of initial system
Q=P*tand(theta);
theta_new=acosd(PFnew);     %the angle of new system
Qnew=P*tand(theta_new);
Q1=Qnew-Q;                           %the reactive power absorbed the capacitor
C=abs(Q1)/(2*pi*(V^2)*f);    %the capacitor supplies Q1 of reactive power.
set(handles.listbox1,'Style','text');
set(handles.listbox1,'string',[...
    'c = ',num2str(theta),10,...
    'Q = ',num2str(Q),10,...
    'cnew = ',num2str(theta_new),10,...
    'Qnew =',num2str(Qnew),10,...
    'Q1 = ',num2str(Q1),10,...
    'C = ',num2str(C),10,...
    ]) ;
function pushbutton2_Callback(hObject, eventdata, handles)
set(handles.listbox1,'Style','listbox');
set(handles.listbox1, 'String',  {
    '% M-file of Example 2.1: ex2_1.m'
    '% Initial values'
    '%initial value'
    'P=50000;'
    'PF=0.8;'
    'V=220;'
    'PFnew=0.95;'
    'f=60;'
    '%------Solution-------'
    'theta=acosd(PF);                      %the angle of initial system  '
    'Q=P*tand(theta);'
    'theta_new=acosd(PFnew)      %the angle of new system'
    'Qnew=P*tand(theta_new);'
    'Q1=Qnew-Q;                       %the reactive power absorbed the capacitor'
    'C=abs(Q1)/(2*pi*(V^2)*f)         %the capacitor supplies Q1 of reactive power.'},'HorizontalAlignment','left');
function pushbutton3_Callback(hObject, eventdata, handles)
close(gcf)
chapter2
function slider1_Callback(hObject, eventdata, handles)
position = evalin ('base','position') ;
b = get(handles.slider1, 'Value');
set(handles.axes1, 'xlim',  [0.5  position(3)] + b );
function slider1_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

function slider2_Callback(hObject, eventdata, handles)
position = evalin ('base','position') ;
a = get(handles.slider2, 'Value');
set(handles.axes1, 'ylim',  [0.5  position(4)] - a );
function slider2_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

function popupmenu1_Callback(hObject, eventdata, handles)

function popupmenu1_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes when uipanel4 is resized.
function uipanel4_ResizeFcn(hObject, eventdata, handles)
set(handles.axes1,'Units','pixels');   
position2 = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized');
assignin('base','position2',position2);
a = imread('ex2_1.png');
b = imresize(a,[position2(4) position2(3)],'bicubic');
c = rgb2gray(b);
c = imadjust(c,[ ],[ ],3);
imshow(c);
