% ******************************************** %
% *** Copyright 2016 by G. W. Chang *** %
% *********** All rights reserved *********** %
% ******************************************** %
function varargout = untitled(varargin)

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @untitled_OpeningFcn, ...
                   'gui_OutputFcn',  @untitled_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end



function untitled_OpeningFcn(hObject, eventdata, handles, varargin)

handles.output = hObject;

axes(handles.axes1);
set(handles.axes1,'Units','pixels');
POSITION = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized');
assignin('base','position',POSITION);
imshow('ex2_2.png');

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes untitled wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = untitled_OutputFcn(hObject, eventdata, handles) 

varargout{1} = handles.output;

function pushbutton1_Callback(hObject, eventdata, handles)

E1=100;
E2=complex(86.6,50);
Z=complex(0,5);
%solution
I=(E1-E2)/Z;
S1=complex(1000,-268);
S2=complex(-1000,-268);
set(handles.listbox1,'Style','text');
set(handles.listbox1,'string',[...
'I = ',num2str(I),' A',10,...
'S1 = ',num2str(S1),' VA',10,...
'S2 = ',num2str(S2),' VA',10,...
'The reactive power absorbed in the series impedance is 536 var',10,...
]) ;



% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)

close(gcf)
chapter2


function edit1_Callback(hObject, eventdata, handles)

function edit1_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit2_Callback(hObject, eventdata, handles)

function edit2_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit3_Callback(hObject, eventdata, handles)

function edit3_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit4_Callback(hObject, eventdata, handles)

function edit4_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit5_Callback(hObject, eventdata, handles)

function edit5_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit6_Callback(hObject, eventdata, handles)

function edit6_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function pushbutton3_Callback(hObject, eventdata, handles)

E1v = str2double(get(handles.edit1, 'string'));   %value
E1t = str2double(get(handles.edit3, 'string'));   %angle
E2v = str2double(get(handles.edit2, 'string'));
E2t = str2double(get(handles.edit4, 'string'));
Za = str2double(get(handles.edit5, 'string'));    
Zi = str2double(get(handles.edit6, 'string'));

thetaE1 = (E1t*pi)/180;
thetaE2 = (E2t*pi)/180;

i = sqrt(-1) ;

E1 = E1v*(cos(thetaE1)+sin(thetaE1)*i);
E2 = E2v*(cos(thetaE2)+sin(thetaE2)*i); 
Z = Za+Zi*i ;

I = (E1-E2)/Z ;
S1 = E1*conj(-I) ;
S2 = E2*conj(I) ;
reactive = abs(I)*abs(I)*Zi ;
set(handles.listbox1,'Style','text');
set(handles.listbox1,'string',[...
'I = ',num2str(I),' A',10,...
'S1 = ',num2str(S1),' VA',10,...
'S2 = ',num2str(S2),' VA',10,...
'The reactive power absorbed in the series impedance is ',num2str(reactive),' var',10,...
]) ;

function pushbutton4_Callback(hObject, eventdata, handles)

handles = guihandles;
guidata(hObject, handles);
set(handles.listbox1,'Style','listbox');
set(handles.listbox1, 'String',  {
'% M-file of Example 2.2: ex2_2.m'
'% Initial values'
'%initial value'
'E1=100;'
'E1angle=0;'
'E1cp=E1*cosd(E1angle)+j*E1*sind(E1angle);  %Convert degree to radian'
'E2=100;'
'E2angle=30;'
'E2cp=E2*cosd(E2angle)+j*E2*sind(E2angle);  %Convert degree to radian'
'Z=complex(0,5);'
'%----------solution-------------'
'I=(E1cp-E2cp)/Z      %from E1 to E2'
'S1=E1cp*conj(-I);   %E1 generating'
'S2=E2cp*conj(I);    %E2 consuming'
'abs(I)^2*abs(Z);'
'The reactive power absorbed in series impedance is |I|^2 * X = 536 var '
},'HorizontalAlignment','left');


function popupmenu1_Callback(~, eventdata, handles)

function popupmenu1_CreateFcn(hObject, ~, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function slider1_Callback(hObject, eventdata, handles)
position = evalin ('base','position') ;
a = get(handles.slider1, 'Value');
set(handles.axes1, 'ylim',  [0.5  position(4)] - a );

function slider1_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function slider2_Callback(hObject, eventdata, handles)
position = evalin ('base','position') ;
b = get(handles.slider2, 'Value');
set(handles.axes1, 'xlim',  [0.5  position(3)] + b );

% --- Executes during object creation, after setting all properties.
function slider2_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes when uipanel2 is resized.
function uipanel2_ResizeFcn(hObject, eventdata, handles)
set(handles.axes1,'Units','pixels');   
position = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized');
position;
assignin('base','position',position);
a = imread('ex2_2.png');
b = imresize(a,[position(4) position(3)],'bicubic');
c = rgb2gray(b);
c = imadjust(c,[ ],[ ],2);
imshow(c);
