% ******************************************** %
% *** Copyright 2016 by G. W. Chang *** %
% *********** All rights reserved *********** %
% ******************************************** %
function varargout = chp2ex3(varargin)

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @chp2ex3_OpeningFcn, ...
    'gui_OutputFcn',  @chp2ex3_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

function chp2ex3_OpeningFcn(hObject, eventdata, handles, varargin)

handles.output = hObject;
imshow('ex2_3.png')
axes(handles.axes1)
set(handles.axes1,'Units','pixels');
POSITION = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized');
assignin('base','position',POSITION);


guidata(hObject, handles);



function varargout = chp2ex3_OutputFcn(hObject, eventdata, handles)

varargout{1} = handles.output;


function pushbutton1_Callback(hObject, eventdata, handles)
close(gcf)
chapter2


function pushbutton2_Callback(hObject, eventdata, handles)
% M-file of Example 2.1: ex2_1.m
% Initial values
P=50000; %W
PF=0.8;  V=220;  PFnew=0.95;
f=60;                                        % system frequency
% Solution
theta=acosd(PF);                       %the angle of initial system
Q=P*tand(theta);
theta_new=acosd(PFnew);     %the angle of new system
Qnew=P*tand(theta_new);
Q1=Qnew-Q;                           %the reactive power absorbed the capacitor
C=abs(Q1)/(2*pi*(V^2)*f);    %the capacitor supplies Q1 of reactive power.
set(handles.listbox1,'Style','text');
set(handles.listbox1,'string',[...
    'c = ',num2str(theta),10,...
    'Q = ',num2str(Q),10,...
    'cnew = ',num2str(theta_new),10,...
    'Qnew =',num2str(Qnew),10,...
    'Q1 = ',num2str(Q1),10,...
    'C = ',num2str(C),10,...
    ]) ;




% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
set(handles.listbox1,'Style','listbox');
set(handles.listbox1, 'String',  {
'%example 1.2'
'%initial value'
'ZL=complex(9.396926,3.4202);'
'%Blanced three phases abc the value is V'
'Vab=complex(173.2,0);'
'Van=complex(86.6,-50);'
'Vbc=complex(-86.6,-149.9955);'
'Vbn=complex(-86.6,-50);'
'Vca=complex(-86.6,149.9955);'
'Vcn=complex(0,100);'
'%The current is lagging 20 degree,and value is 20 A'
'Ian=complex(6.42787,-7.66044);'
'Ibn=complex(-9.848,-1.736481);'
'Icn=complex(3.4202,9.396926);'
'direction=[70 190 310 330]/180*pi'
'magnitude=[1 1 1 0.8]'
'[u,v]=pol2cart(direction,magnitude)'
'%text(0,0,''Icn'');'
'title(''phasor diagram of currents'')'
'compass(u,v);'
},'HorizontalAlignment','left');
% --- Executes on selection change in listbox1.
function listbox1_Callback(hObject, eventdata, handles)

function listbox1_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function popupmenu1_Callback(hObject, eventdata, handles)

function popupmenu1_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider1_Callback(hObject, eventdata, handles)
position = evalin ('base','position') ;
b = get(handles.slider1, 'Value');
set(handles.axes1, 'xlim',  [0.5  position(3)] + b );
function slider1_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function slider2_Callback(hObject, eventdata, handles)
position = evalin ('base','position') ;
a = get(handles.slider2, 'Value');
set(handles.axes1, 'ylim',  [0.5  position(4)] - a );

function slider2_CreateFcn(hObject, eventdata, handles)
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes when uipanel7 is resized.
function uipanel7_ResizeFcn(hObject, eventdata, handles)
set(handles.axes1,'Units','pixels');   
position = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized');
assignin('base','position',position);
a = imread('ex2_3.png');
b = imresize(a,[position(4) position(3)],'bicubic');
c = rgb2gray(b);
c = imadjust(c,[ ],[ ],2);
imshow(c);

set(handles.slider1,'Units','pixels');
d = get(handles.slider1, 'Max');
dd = d * (37/26);
set(handles.slider1,'Max',dd);
set(handles.slider1,'Units','normalized');
function axes3_CreateFcn(hObject, eventdata, handles)



function pushbutton3_CreateFcn(hObject, eventdata, handles)
