% ******************************************** %
% *** Copyright 2016 by G. W. Chang *** %
% *********** All rights reserved *********** %
% ******************************************** %
function varargout = chp2ex4(varargin)

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @chp2ex4_OpeningFcn, ...
    'gui_OutputFcn',  @chp2ex4_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end



function chp2ex4_OpeningFcn(hObject, eventdata, handles, varargin)

handles.output = hObject;
axes(handles.axes1)
set(handles.axes1,'Units','pixels');
POSITION = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized');
assignin('base','position',POSITION);
imshow('ex2_4.png')
% Update handles structure
guidata(hObject, handles);




function varargout = chp2ex4_OutputFcn(hObject, eventdata, handles)

varargout{1} = handles.output;


function pushbutton1_Callback(hObject, eventdata, handles)

Van = 2540;
Limv = str2double(get(handles.edit1, 'string'));  %vaule
Lima = str2double(get(handles.edit2, 'string')); %angle
Zimv = str2double(get(handles.edit3, 'string'));
Zima = str2double(get(handles.edit4, 'string'));

theta1 = (Lima*pi)/180;
theta2 = (Zima*pi)/180;
i = sqrt(-1) ;
Lim = Limv*(cos(theta1)+sin(theta1)*i);
Zim = Zimv*(cos(theta2)+sin(theta2)*i);
Ian = Van/Lim;
linevoltage = Van + Ian*Zim;
magnitudevoltage = abs(linevoltage)*sqrt(3);

set(handles.text6,'Style','text');
set(handles.text6,'string',[...
    'Van = 2540 V',10,...
    'Ian = ',num2str(Ian),' VA',10,...
    'line to neutral voltage at the substation:Van + Ian*ZL  = ',num2str(linevoltage),' VA',10,...
    'the magnitude of voltage at the substation bus is ',num2str(magnitudevoltage),' var',10,...
    ]) ;
function pushbutton2_Callback(hObject, eventdata, handles)

close(gcf)
chapter2
function edit1_Callback(hObject, eventdata, handles)

function edit1_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit2_Callback(hObject, eventdata, handles)

function edit2_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit3_Callback(hObject, eventdata, handles)
function edit3_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit4_Callback(hObject, eventdata, handles)
function edit4_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function pushbutton3_Callback(hObject, eventdata, handles)
ZL=complex(0.362346,1.352296);
Vlne=4.4*10^3;
Ian=complex(109.985,63.5);
set(handles.text6,'Style','text');
set(handles.text6,'string',[...
    'Van = 2540 V',10,...
    'Ian = ',num2str(Ian),' VA',10,...
    'line to neutral voltage at the substation:Van + Ian*ZL  = 2667+125.774i VA',10,...
    'the magnitude of voltage at the substation bus is 4.62kv',10,...
    ]) ;

function pushbutton4_Callback(hObject, eventdata, handles)

guidata(hObject, handles);
set(handles.text6,'Style','listbox');
set(handles.text6, 'String',  {
    '% Initial values'
    'Van = 2540;'
    'ZL=complex(0.362346,1.352296);'
    'Vlne=4.4*10^3;'
    '-----Answer-----'
    'Ian=complex(109.985,63.5);'
    'line to neutral voltage=Van + Ian*ZL ;'
    },'HorizontalAlignment','left');

function popupmenu1_Callback(hObject, eventdata, handles)
function popupmenu1_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function slider2_Callback(hObject, eventdata, handles)
position = evalin ('base','position') ;
b = get(handles.slider2, 'Value');
set(handles.axes1, 'xlim',  [0.5  position(3)] + b );

function slider2_CreateFcn(hObject, eventdata, handles)
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

function slider1_Callback(hObject, eventdata, handles)
position = evalin ('base','position') ;
a = get(handles.slider1, 'Value');
set(handles.axes1, 'ylim',  [0.5  position(4)] - a );


function slider1_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes when uipanel9 is resized.
function uipanel9_ResizeFcn(hObject, eventdata, handles)
set(handles.axes1,'Units','pixels');   
position = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized');
position;
assignin('base','position',position);
a = imread('ex2_4.png');
b = imresize(a,[position(4) position(3)],'bicubic');
c = rgb2gray(b);
c = imadjust(c,[ ],[ ],2);
imshow(c);

set(handles.slider1,'Units','pixels');
set(handles.slider1,'Min',-330);
set(handles.slider1,'Units','normalized');
