% ******************************************** %
% *** Copyright 2016 by G. W. Chang *** %
% *********** All rights reserved *********** %
% ******************************************** %
function varargout = chp2ex5(varargin)
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @chp2ex5_OpeningFcn, ...
                   'gui_OutputFcn',  @chp2ex5_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

function chp2ex5_OpeningFcn(hObject, eventdata, handles, varargin)

handles.output = hObject;
imshow('ex2_5.png')
axes(handles.axes1)
set(handles.axes1,'Units','pixels');
POSITION = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized');
assignin('base','position',POSITION);


% Update handles structure
guidata(hObject, handles);

function varargout = chp2ex5_OutputFcn(hObject, eventdata, handles) 
varargout{1} = handles.output;



function pushbutton1_Callback(hObject, eventdata, handles)
% M_File for Example 2.5: ex2_5.m
%initial value
V=440;
hp=15;
efficiency=0.9;  %  90%
PF=0.8;         %lagging
W=hp*746;
%solution
IL=abs(W/(sqrt(3)*V*PF*efficiency))   
Iangle=acosd(PF)
Icp=IL*cosd(Iangle)+j*IL*sind(Iangle)  %%Convert degree to radian
P=sqrt(3)*V*IL*cosd(Iangle)
Q=sqrt(3)*V*IL*sind(Iangle)

set(handles.text2, 'String', {
'IL=|W/(sqrt(3)*V*PF*efficiency)|-acos(0.8)=20.3931-36.8699 A'
'20.39310 A drawn from a three-phase 440-V line by a three-phase 15-hp motor'
'12433.3333W and 9325VAR drawn from the line.'
    },'HorizontalAlignment','left');

function pushbutton2_Callback(hObject, eventdata, handles)
close(gcf)
chapter2

function popupmenu1_Callback(hObject, eventdata, handles)

function popupmenu1_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function pushbutton3_Callback(hObject, eventdata, handles)
guidata(hObject, handles);
set(handles.text2,'Style','listbox');
set(handles.text2, 'String',  {
'% Matlab M-file for Example 2.5: ex2_5.m'
'% Clean previous value'
'clc'
'clear all'
'%initial value'
'V=440;'
'hp=15;'
'efficiency=0.9;                        %  90%'
'PF=0.8;                                %lagging'
'W=hp*746;'
'%solution'
'IL=abs(W/(sqrt(3)*V*PF*efficiency));'   
'IL_mag=abs(IL);'
'IL_ang=angle(IL)*180/pi;                % Rad => Degree'
'Iangle=acosd(PF);'
'disp(['' IL=|W/(sqrt(3)*V*PF*efficiency)|-acos(0.8)='',num2str(IL_mag),''-'',num2str(Iangle),'' A''])'
'Icp=IL*cosd(Iangle)+j*IL*sind(Iangle);  %Convert degree to radian'
'P=sqrt(3)*V*IL*cosd(Iangle);'
'Q=sqrt(3)*V*IL*sind(Iangle);'

'disp([num2str(IL_mag),'''',num2str(IL_ang),'' A '',''drawn from a three-phase 440-V line by a three-phase 15-hp motor'']);'
'disp([num2str(P),''W and '',num2str(Q), ''VAR drawn from the line'']);'

    },'HorizontalAlignment','left');

% --- Executes on slider movement.
function slider1_Callback(hObject, eventdata, handles)
position = evalin ('base','position') ;
b = get(handles.slider1, 'Value');
set(handles.axes1, 'xlim',  [0.5  position(3)] + b );

function slider1_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

function slider2_Callback(hObject, eventdata, handles)
position = evalin ('base','position') ;
a = get(handles.slider2, 'Value');
set(handles.axes1, 'ylim',  [0.5  position(4)] - a );
function slider2_CreateFcn(hObject, eventdata, handles)
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes when uipanel1 is resized.
function uipanel1_ResizeFcn(hObject, eventdata, handles)
set(handles.axes1,'Units','pixels');   
position = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized');
position;
assignin('base','position',position);
a = imread('ex2_5.png');
b = imresize(a,[position(4) position(3)],'bicubic');
c = rgb2gray(b);
c = imadjust(c,[ ],[ ],2);
imshow(c);
