% ******************************************** %
% *** Copyright 2016 by G. W. Chang *** %
% *********** All rights reserved *********** %
% ******************************************** %
function varargout = chp2ex6(varargin)

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @chp2ex6_OpeningFcn, ...
    'gui_OutputFcn',  @chp2ex6_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

function chp2ex6_OpeningFcn(hObject, eventdata, handles, varargin)

handles.output = hObject;
axes(handles.axes1)
imshow('ex2_6.png')
set(handles.axes1,'Units','pixels');
POSITION = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized');
assignin('base','position',POSITION);

guidata(hObject, handles);

function varargout = chp2ex6_OutputFcn(hObject, eventdata, handles)

varargout{1} = handles.output;


function pushbutton1_Callback(hObject, eventdata, handles)

close(gcf)
chapter2


function pushbutton2_Callback(hObject, eventdata, handles)
% M_File for Example 2.6: ex2_6.m
%initial value
Vbase=4400;
Ibase=127;
Vline=4400;                              %the data get from ex2.4
Zl=1.4;                                   %the data get from ex2.4
Zlangle=75;
Zlcp=Zl*cosd(Zlangle)+j*Zl*sind(Zlangle); %Convert degree to radian
Zline=20;                                 %the data get from ex2.4
Zlineangle=30;
Zlinecp=Zline*cosd(Zlineangle)+j*Zline*sind(Zlineangle);
Van=Vline/sqrt(3);
Ian=Van/Zlinecp;
%solution
Zbase = (4400/sqrt(3))/127;
disp('The line impedance is');
Z = Zlcp/Zbase;              %the data get from ex2.4
Ianpu=Ian/Ibase;
Van=complex(1,0)+Ianpu*Z;
VLN=abs(Van)*Vbase/sqrt(3);
VLL=abs(Van)*Vbase;
set(handles.text2,'Style','text');
set(handles.text2,'string',[...
    'Zbase = ',num2str(Zbase),10,...
    'The line impedance is',10,...
    'Z = ',num2str(Z),10,...
    'The line-to-neutral voltage at the substation Van is 1.0507 per unit with angle of 2.7002 deg.',10,...
    'The magnitude of line-to-neutral voltage at the substation bus is 2669.0452 V',10,...
    'The magnitude of line-to-line voltage at the substation bus is 4622.9218 V',10,...
    ]) ;

function pushbutton3_Callback(hObject, eventdata, handles)
guidata(hObject, handles);
set(handles.text2,'Style','listbox');
set(handles.text2, 'String',  {
'% M-file for Example 2.6: ex2_6.m'
'% Clean previous value'
'clc'
'clear all'
'% Initial the data from ex2.6'
'Vbase=4400;'
'Ibase=127;'
'% Initial the data get from ex2.3'
'Vline=4400;'                              
'ZL=1.4;       ZL_angle=75;'
'Zline=20;     Zline_angle=30;'
'% Convert degree to radian'
'ZL_cp=ZL*cosd(ZL_angle)+j*ZL*sind(ZL_angle);' 
'Zline_cp=Zline*cosd(Zline_angle)+j*Zline*sind(Zline_angle);'
'% Calculate voltage and current in phase'
'Van=Vline/sqrt(3)'
'Ian=Van/Zline_cp'
'% Solution'
'% Turning the value into pu form'
'Zbase=(4400/sqrt(3))/127'
'disp(''The line impedance is'')'
'Z=ZL_cp/Zbase'                        
'Ian_pu=Ian/Ibase'
'% Calculate voltage in phase a and turn it into line-line voltage'
'Van=complex(1,0)+Ian_pu*Z'
'Mag_Van=abs(Van);'
'ang=angle(Van)*180/pi;'
'disp([''The line-to-neutral voltage at the substation Van is '',num2str(Mag_Van),'' per unit with angle of '',num2str(ang),'' deg.''])'
'VLN=abs(Van)*Vbase/sqrt(3)'
'disp([''The magnitude of line-to-neutral voltage at the substation bus is '',num2str(VLN),'' V'']);'
'VLL=abs(Van)*Vbase'
'disp([''The magnitude of line-to-line voltage at the substation bus is '',num2str(abs(VLL)),'' V'']);'
   
    },'HorizontalAlignment','left');

function popupmenu1_Callback(hObject, eventdata, handles)

function popupmenu1_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function slider1_Callback(hObject, eventdata, handles)
position = evalin ('base','position') ;
b = get(handles.slider1, 'Value');
set(handles.axes1, 'xlim',  [0.5  position(3)] + b );
function slider1_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



function slider2_Callback(hObject, eventdata, handles)
position = evalin ('base','position') ;
a = get(handles.slider2, 'Value');
set(handles.axes1, 'ylim',  [0.5  position(4)] - a );
function slider2_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes when uipanel3 is resized.
function uipanel3_ResizeFcn(hObject, eventdata, handles)
set(handles.axes1,'Units','pixels');   
position = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized');
position;
assignin('base','position',position);
a = imread('ex2_6.png');
b = imresize(a,[position(4) position(3)],'bicubic');
c = rgb2gray(b);
c = imadjust(c,[ ],[ ],2);
imshow(c);
