% ******************************************** %
% *** Copyright 2016 by G. W. Chang *** %
% *********** All rights reserved *********** %
% ******************************************** %
function varargout = chp2ex7(varargin)
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @chp2ex7_OpeningFcn, ...
    'gui_OutputFcn',  @chp2ex7_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

function chp2ex7_OpeningFcn(hObject, eventdata, handles, varargin)

handles.output = hObject;


axes(handles.axes1);
imshow('ex2_7.png');
set(handles.axes1,'Units','pixels');
POSITION = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized');
assignin('base','position',POSITION);
% Update handles structure
guidata(hObject, handles);
function varargout = chp2ex7_OutputFcn(hObject, eventdata, handles)
varargout{1} = handles.output;

function pushbutton1_Callback(hObject, eventdata, handles)
close(gcf)
chapter2
% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
Xold=0.25; %pu
Vold=18;  %kV
Sold=500; %MVA
Vnew=20;  %kV
Snew=100; %MVA
%solution
Xnew=Xold*(Vold/Vnew)^2*(Snew/Sold);
set(handles.text2,'Style','text');
set(handles.text2,'string',[...
    'By Eq. (2.56) Xnew=Xold*(Vold/Vnew)^2*(Snew/Sold) ',10,...
    'X" =0.25*((18*18)/(25*25)) *(100/500) =0.0405 per unit ',10,...
    ]) ;


function pushbutton3_Callback(hObject, eventdata, handles)
guidata(hObject, handles);
set(handles.text2,'Style','listbox');
set(handles.text2, 'String',  {
'%example 2.7'
'%initial value'
'Xold=0.25; %pu'
'Vold=18;  %kV'
'Sold=500; %MVA'
'Vnew=20;  %kV'
'Snew=100; %MVA'
'%------solution-----'
'Xnew=Xold*(Vold/Vnew)^2*(Snew/Sold);'
},'HorizontalAlignment','left');

function popupmenu1_Callback(hObject, eventdata, handles)
% --- Executes during object creation, after setting all properties.
function popupmenu1_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
% --- Executes on slider movement.
function slider1_Callback(hObject, eventdata, handles)
position = evalin ('base','position') ;
b = get(handles.slider1, 'Value');
set(handles.axes1, 'xlim',  [0.5  position(3)] + b );

function slider1_CreateFcn(hObject, eventdata, handles)
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

function slider2_Callback(hObject, eventdata, handles)
position = evalin ('base','position') ;
a = get(handles.slider2, 'Value');
set(handles.axes1, 'ylim',  [0.5  position(4)] - a );

function slider2_CreateFcn(hObject, eventdata, handles)
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end
function text2_Callback(hObject, eventdata, handles)
function text2_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes when uipanel1 is resized.
function uipanel1_ResizeFcn(hObject, eventdata, handles)
set(handles.axes1,'Units','pixels');   
position = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized');
position;
assignin('base','position',position);
a = imread('ex2_7.png');
b = imresize(a,[position(4) position(3)],'bicubic');
c = rgb2gray(b);
c = imadjust(c,[ ],[ ],2);
imshow(c);

set(handles.slider1,'Units','pixels');
set(handles.slider1,'Max',180);
set(handles.slider1,'Units','normalized');
