% ******************************************** %
% *** Copyright 2016 by G. W. Chang *** %
% *********** All rights reserved *********** %
% ******************************************** %
function varargout = chp2ex9(varargin)
% CHP2EX9 MATLAB code for chp2ex9.fig

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @chp2ex9_OpeningFcn, ...
                   'gui_OutputFcn',  @chp2ex9_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

function chp2ex9_OpeningFcn(hObject, eventdata, handles, varargin)

handles.output = hObject;
axes(handles.axes1);
imshow('ex3_12.png');
set(handles.axes1,'Units','pixels');
POSITION = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized');
assignin('base','position',POSITION);
guidata(hObject, handles);


function varargout = chp2ex9_OutputFcn(hObject, eventdata, handles) 

varargout{1} = handles.output;

function pushbutton1_Callback(hObject, eventdata, handles)

VA=1;
IA=complex(2.16,-1.046)
IB=complex(-1.9859,-1.3476)
IC=complex(-0.174,2.39367)
% disp('Low voltage side current lag by 30 , so in per unit:')
Ia=complex(1.3476,-1.9859)
Ib=complex(-2.3936,0.174)
Ic=complex(1.0462,0.16)
% disp('The transformer reactance modified for chosen base is 0.11*100/330 = 1/30 per  unit')
Vt=complex(0.9322,-0.4551)
% disp('Re{Vt*Ia}=1.0374*2.4cos(-26.02+55.84) =2.160 per unit')
set(handles.text2,'Style','text');
set(handles.text2,'string',[...
'The current supplied to the load : 602.45A',10,...
'The base current at the load is 100000/(3)^1/2*230 = 251.02 A',10,...
'the phasor angle of the load current is 25.84 lag',10,...
'Low voltage side current lag by 30 , so in per unit:',10,...
'The transformer reactance modified for chosen base is 0.11*100/330 = 1/30 per unit',10,...
'Re{Vt*Ia}=1.0374*2.4cos(-26.02+55.84) =2.160 per unit',10,...
]) ;



% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
close(gcf)
chapter3
function popupmenu1_Callback(hObject, eventdata, handles)
function popupmenu1_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider1_Callback(hObject, eventdata, handles)
position = evalin ('base','position') ;
b = get(handles.slider1, 'Value');
set(handles.axes1, 'xlim',  [0.5  position(3)] + b );
function slider1_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end
function slider2_Callback(hObject, eventdata, handles)
position = evalin ('base','position') ;
a = get(handles.slider2, 'Value');
set(handles.axes1, 'ylim',  [0.5  position(4)] - a );
function slider2_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on selection change in text2.
function text2_Callback(hObject, eventdata, handles)

function text2_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)

set(handles.text2,'Style','listbox');
set(handles.text2, 'String',  {
'% M-file for Example 3.12: ex3_12.m'
'% Clean previous value'
'clc'
'clear all'
'disp(''The current supplied to the load : '')'
'I=240*10^3/(sqrt(3)*230)'
'disp(''The base current at the load is '')'
'Ib=100*10^3/(sqrt(3)*230)'
'disp(''The phasor angle of the load current is 25.84 lag'')'
'VA=1;'
'IA=I/Ib*(cosd(-25.84)+j*sind(-25.84))'
'IB=I/Ib*(cosd(-25.84-120)+j*sind(-25.84-120))'
'IC=I/Ib*(cosd(-25.84+120)+j*sind(-25.84+120))'
'disp(''Low voltage side current lag by 30 , so in per unit:'')'
'Ia=IA*(cosd(-30)+j*sind(-30))'
'Ib=IB*(cosd(-30)+j*sind(-30))'
'Ic=IC*(cosd(-30)+j*sind(-30))'
'disp(''The transformer reactance modified for chosen base is '')'
'X=0.11*100/330'
'%the terminal voltage of the generator'
'Vt=VA*(cosd(-30)+j*sind(-30))+j*X*Ia'
'disp(''The real power supplied by the generator is:'')'
'P=real(Vt*conj(Ia))'

 },'HorizontalAlignment','left');  


% --- Executes when uipanel3 is resized.
function uipanel3_ResizeFcn(hObject, eventdata, handles)
set(handles.axes1,'Units','pixels');   
position = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized');
position;
assignin('base','position',position);
a = imread('ex3_12.png');
b = imresize(a,[position(4) position(3)],'bicubic');
c = rgb2gray(b);
c = imadjust(c,[ ],[ ],2);
imshow(c);



set(handles.slider2,'Units','pixels');
set(handles.slider2,'Min',-1500);
set(handles.slider2,'Units','normalized');
