% ******************************************** %
% *** Copyright 2016 by G. W. Chang *** %
% *********** All rights reserved *********** %
% ******************************************** %
function varargout = chp3ex13(varargin)

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @chp2ex13_OpeningFcn, ...
                   'gui_OutputFcn',  @chp2ex13_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

function chp2ex13_OpeningFcn(hObject, eventdata, handles, varargin)

handles.output = hObject;

axes(handles.axes1);
set(handles.axes1,'Units','pixels');
POSITION = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized');
assignin('base','position',POSITION);
imshow('ex3_13.png');
% Update handles structure
guidata(hObject, handles);

function varargout = chp2ex13_OutputFcn(hObject, eventdata, handles) 

varargout{1} = handles.output;


function pushbutton1_Callback(hObject, eventdata, handles)

Icirc=complex(0,-0.25);
ITa=complex(0.4,-0.05);
ITb=complex(0.4,-0.55);
STa=complex(0.4,0.05);
STb=complex(0.4,0.55);
set(handles.text2,'Style','text');
set(handles.text2,'string',[...
'From GV alone we obtain Load current : Icirc = 0.05/j0.2 = -j0.25 pu',10,...
'and with GV short-circuited, the current in each path is half the load current, or 0.4 - j0.3. Then, superimposing the circulating current gives',10,...
'ITa = 0.4-j0.3-(-j0.25) = 0.4-j0.05 pu',10,...
'ITb = 0.4-j0.3+(-j0.25) = 0.4-j0.055 pu',10,...
'STa = 0.4+j0.05  pu',10,...
'STb = 0.4+j0.55  pu',10,...
'right hand side is an equivalent circuit for Example 3.13',10,...
]) ;

function pushbutton2_Callback(hObject, eventdata, handles)
close(gcf)
chapter3

function popupmenu1_Callback(hObject, eventdata, handles)

function popupmenu1_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function slider1_Callback(hObject, eventdata, handles)
position = evalin ('base','position') ;
b = get(handles.slider1, 'Value');
set(handles.axes1, 'xlim',  [0.5  position(3)] + b );

function slider1_CreateFcn(hObject, eventdata, handles)
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

function slider2_Callback(hObject, eventdata, handles)
position = evalin ('base','position') ;
a = get(handles.slider2, 'Value');
set(handles.axes1, 'ylim',  [0.5  position(4)] - a );

function slider2_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

function text2_Callback(hObject, eventdata, handles)

function text2_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function pushbutton3_Callback(hObject, eventdata, handles)
set(handles.text2,'Style','listbox');
set(handles.text2, 'String',  {
'% M-file of Example 3.13: ex3_13.m'
'%Clean previous value'
'clc'
'clear all'
'% initial value'
'V=1;'
'Z=0.8+j*0.6;'
'delta_V=0.05;'
'Xt=j*0.1;'
'Xt2=j*0.1;'
'% solution'
'IL=V/Z;'
'Icir=delta_V/(Xt+Xt2);'
'% the current in each path is half the load current'
'ITa=IL/2-Icir;'
'ITv=IL/2-Icir;'
'STa=1*conj(ITa)'
'STv=1*conj(ITv)'
 },'HorizontalAlignment','left');  

function pushbutton4_Callback(hObject, eventdata, handles)
set(handles.axes3,'Units','pixels')
position2 = get(handles.axes3,'Position');
set(handles.axes3,'Units','normalized')
assignin('base','position2',position2);
a2 = imread('ex3_13(2).png');
b2 = imresize(a2,[position2(4) position2(3)],'bicubic');
c2 = rgb2gray(b2);
c2 = imadjust(c2,[ ],[ ],3);
imshow(c2,'parent',handles.axes3)

function uipanel3_ResizeFcn(hObject, eventdata, handles)

set(handles.axes1,'Units','pixels');   
position = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized');
position;
assignin('base','position',position);
a = imread('ex3_13.png');
b = imresize(a,[position(4) position(3)],'bicubic');
c = rgb2gray(b);
c = imadjust(c,[ ],[ ],3);
imshow(c);


set(handles.axes3,'Units','pixels')
position3 = get(handles.axes3,'Position');
set(handles.axes3,'Units','normalized')
assignin('base','position3',position3);
a2 = imread('ex3_13(2).png');
b2 = imresize(a2,[position3(4) position3(3)],'bicubic');
c2 = rgb2gray(b2);
c2 = imadjust(c2,[ ],[ ],3);
imshow(c2,'parent',handles.axes3)


set(handles.slider2,'Units','pixels');
set(handles.slider2,'Min',-250);
set(handles.slider2,'Units','normalized');
