% ******************************************** %
% *** Copyright 2016 by G. W. Chang *** %
% *********** All rights reserved *********** %
% ******************************************** %
function varargout = chp3ex15(varargin)

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @chp2ex14_OpeningFcn, ...
    'gui_OutputFcn',  @chp2ex14_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

function chp2ex14_OpeningFcn(hObject, eventdata, handles, varargin)

handles.output = hObject;

axes(handles.axes1);
set(handles.axes1,'Units','pixels');
POSITION = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized');
assignin('base','position',POSITION);
imshow('ex3_15.png');


% Update handles structure
guidata(hObject, handles);

function varargout = chp2ex14_OutputFcn(hObject, eventdata, handles)

varargout{1} = handles.output;

function pushbutton1_Callback(hObject, eventdata, handles)

set(handles.text2,'Style','text');
set(handles.text2,'string',[...
    'Base kVa Sb = 635000000',10,...
    'Base line voltage VLLb = 24000',10,...
    'Base current Ib = 1.5276e+04',10,...
    'Base impedance Zb = 0.9071',10,...
    'Xd = 1.5639',10,...
    'In per unit : Xd_pu = 1.7241 pu',10,...
    'In per unit : Ei = Va + jXd*Ia = ',10,...
    'Ei = 1.7515 + 1.5517i',10,...
    'If = 1.6400e+03',10,...
    ])



% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)

close(gcf)
chapter3


function popupmenu1_Callback(hObject, eventdata, handles)

function popupmenu1_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function slider1_Callback(hObject, eventdata, handles)
position = evalin ('base','position') ;
b = get(handles.slider1, 'Value');
set(handles.axes1, 'xlim',  [0.5  position(3)] + b );
function slider1_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

function slider2_Callback(hObject, eventdata, handles)
position = evalin ('base','position') ;
a = get(handles.slider2, 'Value');
set(handles.axes1, 'ylim',  [0.5  position(4)] - a );

% --- Executes during object creation, after setting all properties.
function slider2_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on selection change in text2.
function text2_Callback(hObject, eventdata, handles)
% hObject    handle to text2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns text2 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from text2


% --- Executes during object creation, after setting all properties.
function text2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
set(handles.text2,'Style','listbox');
set(handles.text2, 'String',  {
'% M-file for Example 3.15: ex3_15.m'
'% Clean previous value'
'clc'
'clear all'
'%Initial value'
'f=60;'
'w=2*pi*f;'
'Ls=2.7656*10^(-3);'
'Ms=1.3828*10^(-3);'
'Mf=31.6950*10^(-3);'
'disp(''Base kVa = '')'
'Sb=635*10^6'
'disp(''Base line voltage = '')'
'VLLb=24*10^3'
'disp(''Base current = '')'
'Ib=Sb/(sqrt(3)*VLLb)'
'disp(''Base impedance =  '')'
'Zb=VLLb^2/Sb'
'Xd=w*(Ls+Ms)'
'disp(''In per unit : Xd = '')'
'Xd_pu=Xd/Zb'
'%For per unit ,calculate the lagging Ia'
'Va=1;'
'Ia_mag=1;'
'Ia_ang=25.8419;'
'Ia=Ia_mag*(cosd(-Ia_ang)+j*sind(-Ia_ang));'
'disp(''In per unit : Ei = Va + jXd*Ia = '')'
'Ei=Va+j*Xd_pu*Ia'
'%Field current'
'If=19596/(w*Mf)'
    
    },'HorizontalAlignment','left');


% --- Executes when uipanel3 is resized.
function uipanel3_ResizeFcn(hObject, eventdata, handles)
set(handles.axes1,'Units','pixels');
position = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized');
position;
assignin('base','position',position);
a = imread('ex3_15.png');
b = imresize(a,[position(4) position(3)],'bicubic');
c = rgb2gray(b);
c = imadjust(c,[ ],[ ],2);
imshow(c);
set(handles.slider2,'Units','pixels');
set(handles.slider2,'Min',-450);
set(handles.slider2,'Units','normalized');
set(handles.slider1,'Units','pixels');
set(handles.slider1,'Max',180);
set(handles.slider1,'Units','normalized');
