% ******************************************** %
% *** Copyright 2016 by G. W. Chang *** %
% *********** All rights reserved *********** %
% ******************************************** %
function varargout = chp3ex18(varargin)

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @chp2ex14_OpeningFcn, ...
    'gui_OutputFcn',  @chp2ex14_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

function chp2ex14_OpeningFcn(hObject, eventdata, handles, varargin)

handles.output = hObject;

axes(handles.axes1);
set(handles.axes1,'Units','pixels');
POSITION = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized');
assignin('base','position',POSITION);
imshow('ex3_18.png');
% Update handles structure
guidata(hObject, handles);

function varargout = chp2ex14_OutputFcn(hObject, eventdata, handles)

varargout{1} = handles.output;

function pushbutton1_Callback(hObject, eventdata, handles)

set(handles.text2,'Style','text');
set(handles.text2,'string',[...
    '(a) Terminal voltage as the reference phaso',10,...
    'Vt = 0.9500',10,...
    'S_pu = 0.7220 + 0.1805i',10,...
    'Ia = 0.7600 - 0.1900i',10,...
    'Ei = 1.2776 + 1.3103i',10,...
    '(b) The point k corresponding to the actual operating conditions',10,...
    'Sk = 0.8000 + 0.2000i',10,...
    'The distance n-k equals 1.1173',10,...
    'distance = 1.1173',10,...
    'Ei_abs = 1.8300',10,...
    ])

function pushbutton2_Callback(hObject, eventdata, handles)
close(gcf)
chapter3
function popupmenu1_Callback(hObject, eventdata, handles)

function popupmenu1_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider1_Callback(hObject, eventdata, handles)
position = evalin ('base','position') ;
b = get(handles.slider1, 'Value');
set(handles.axes1, 'xlim',  [0.5  position(3)] + b );
function slider1_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function slider2_Callback(hObject, eventdata, handles)
position = evalin ('base','position') ;
a = get(handles.slider2, 'Value');
set(handles.axes1, 'ylim',  [0.5  position(4)] - a );

% --- Executes during object creation, after setting all properties.
function slider2_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



function text2_Callback(hObject, eventdata, handles)

function text2_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function pushbutton3_Callback(hObject, eventdata, handles)
set(handles.text2,'Style','listbox');
set(handles.text2, 'String',  {
'% M-file of Example 3.18: ex3_18.m'
'%Clean previous value'
'clc'
'clear all'
'% initial value'
'V=22.8*10^3;%V'
'S=458.47+j*114.62;%MVA'
'Sbase=635;%MVA'
'Vbase=24*10^3;%V'
'Xd=1.7241;'
'% solution'
'% (a) Terminal voltage as the reference phaso'
'Vt=V/Vbase'
'S_pu=S/Sbase'
'Ia=conj(S_pu)/Vt'
'Ei=Vt+j*Xd*Ia'
'% (b) The point k corresponding to the actual operating conditions'
'Sk=S_pu/Vt^2'
'% The distance n-k equals 1.1173'
'distance=1.1173'
'Ei_abs=distance*Vt^2*Xd/Vt'
    },'HorizontalAlignment','left');

function uipanel3_ResizeFcn(hObject, eventdata, handles)
set(handles.axes1,'Units','pixels');
position = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized');
position;
assignin('base','position',position);
a = imread('ex3_18.png');
b = imresize(a,[position(4) position(3)],'bicubic');
c = rgb2gray(b);
c = imadjust(c,[ ],[ ],2);
imshow(c);

set(handles.slider2,'Units','pixels');
set(handles.slider2,'Min',-70);
set(handles.slider2,'Units','normalized');
set(handles.slider1,'Units','pixels');
set(handles.slider1,'Max',200);
set(handles.slider1,'Units','normalized');


% --- Executes on selection change in popupmenu2.
function popupmenu2_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu2 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu2


% --- Executes during object creation, after setting all properties.
function popupmenu2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
