% ******************************************** %
% *** Copyright 2016 by G. W. Chang *** %
% *********** All rights reserved *********** %
% ******************************************** %
function varargout = chp2ex6(varargin)

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @chp2ex6_OpeningFcn, ...
                   'gui_OutputFcn',  @chp2ex6_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

function chp2ex6_OpeningFcn(hObject, eventdata, handles, varargin)

handles.output = hObject;
axes(handles.axes1);
set(handles.axes1,'Units','pixels');
POSITION = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized');
assignin('base','position',POSITION);

imshow('ex3_7.png');

guidata(hObject, handles);


function varargout = chp2ex6_OutputFcn(hObject, eventdata, handles) 

varargout{1} = handles.output;


function pushbutton1_Callback(hObject, eventdata, handles)
set(handles.text2,'Style','text');
set(handles.text2,'string',[...
'Base voltage for circuit A : 0.1*138 =13.8 kV',10,...
'Base voltage for circuit C : 0.5*138 =69 kV',10,...
'Base impedance for circuit C : 69^2*1000/10000 = 476 [',10,...
'Per unit impedance of load in circuit C : 300/476 =0.63 pu',10,...
'Base impedance of circuit B : 138^2*1000/10000 =1900 [',10,...
'Impedance of load referred to circuit B : 300*262 = 1200 [',10,...
'Per unit impedance of load referred to circuit B : 1200/1900 = 0.63 pu',10,...
'Base impedance for circuit A : 13.8^2*1000/10000=19 [',10,...
'Impedance of load referred to circuit A : 300*2^2*0.1^2 = 12 [',10,...
'Per unit impedance of load referred to circuit A : 12/19 = 0.63 pu',10,...
])


function pushbutton2_Callback(hObject, eventdata, handles)
close(gcf)
chapter3
function pushbutton3_Callback(hObject, eventdata, handles)
set(handles.text2,'Style','listbox');
set(handles.text2, 'String',  {
'% M-file for Example 3.7: ex3_7.m'
'% Clean previous value'
'clc'
'clear all'
'%Turns ratio'
'a1=0.1;'
'a2=0.5;'
'disp(''Base voltage for circuit A :'')'
'Vb_A=a1*138'
'disp(''Base voltage for circuit C :'')'
'Vb_C=a2*138'
'disp(''Base impedance for circuit C : '')'
'Zb_C=69^2*1000/10000'
'disp(''Per unit impedance of load in circuit C :'')'
'Zload_pu=300/Zb_C'
'disp(''Base impedance of circuit B : '')'
'Zb_B=138^2*1000/10000'
'disp(''Impedance of load referred to circuit B : '')'
'Zload_B=300*(1/a2)^2'
'disp(''Per unit impedance of load referred to circuit B : '')'
'Zload_B_pu=Zload_B/Zb_B'
'disp(''Base impedance for circuit A : '')'
'Zb_A=13.8^2*1000/10000'
'disp(''Impedance of load referred to circuit A : '')'
'Zload_A=300*(1/a2)^2*a1^2;'
'disp(''Per unit impedance of load referred to circuit A : '')'
'Zload_A_pu=Zload_A/Zb_A;'
 },'HorizontalAlignment','left');  



function edit1_Callback(hObject, eventdata, handles)
function edit1_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function text2_Callback(hObject, eventdata, handles)
function text2_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function slider1_Callback(hObject, eventdata, handles)

position = evalin ('base','position') ;
b = get(handles.slider1, 'Value');
set(handles.axes1, 'xlim',  [0.5  position(3)] + b );


function slider1_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

function slider2_Callback(hObject, eventdata, handles)
position = evalin ('base','position') ;
a = get(handles.slider2, 'Value');
set(handles.axes1, 'ylim',  [0.5  position(4)] - a );


function slider2_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end
function popupmenu1_Callback(hObject, eventdata, handles)
function popupmenu1_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes when uipanel1 is resized.
function uipanel1_ResizeFcn(hObject, eventdata, handles)
set(handles.axes1,'Units','pixels');   
position = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized');
position;
assignin('base','position',position);
a = imread('ex3_7.png');
b = imresize(a,[position(4) position(3)],'bicubic');
c = rgb2gray(b);
c = imadjust(c,[ ],[ ],2);
imshow(c);

set(handles.slider2,'Units','pixels');
set(handles.slider2,'Min',-380);
set(handles.slider2,'Units','normalized');
