% ******************************************** %
% *** Copyright 2016 by G. W. Chang *** %
% *********** All rights reserved *********** %
% ******************************************** %
function varargout = chp7ex11(varargin)

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @chp7ex11_OpeningFcn, ...
    'gui_OutputFcn',  @chp7ex11_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

function chp7ex11_OpeningFcn(hObject, eventdata, handles, varargin)
handles.output = hObject;
imshow('ex7_11.png','parent',handles.axes1)
set(handles.axes1,'Units','pixels');
POSITION = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized');
assignin('base','position',POSITION);
guidata(hObject, handles);

function varargout = chp7ex11_OutputFcn(hObject, eventdata, handles)
varargout{1} = handles.output;


function pushbutton1_Callback(hObject, eventdata, handles)
%Example 7.11
%solution
%calculate value of I
S=complex(98.12,65.085);
disp('|I|=117744/(3^(1/2)*230*1) ');
ans=117744/(3^(1/2)*230*1);
Zbase=230*230/100;
%calculate the loss of real part
% disp('Using the R and X parameters of table 6.6');
% disp('I^2*R loss=3*(295.56)^2*0.00744*529*10^-6 in 3MW');
ans=3*(295.56)^2*0.00744*529*10^-6;
%calculate the loss of imaginary part
% disp('I^2*X loss=3*(295.56)^2*0.03720*529*10^-6 in Mvar');
ans=3*(295.56)^2*0.03720*529*10^-6;
set(handles.text1, 'String',  {
    'Using the R and X parameters of table 6.6'
    ''
    'Calculate the loss of real part:'
    
    'I^2*R loss=3*(295.56)^2*0.00744*529*10^-6 in 3MW'
    'ans=3*(295.56)^2*0.00744*529*10^-6 =1.0314'
    ''
    'Calculate the loss of imaginary part:'
    
    'I^2*X loss=3*(295.56)^2*0.03720*529*10^-6 in Mvar'
    'ans=3*(295.56)^2*0.03720*529*10^-6 = 5.1572'
      },'HorizontalAlignment','left');


function pushbutton2_Callback(hObject, eventdata, handles)
close(gcf)
chapter7

function popupmenu1_Callback(hObject, eventdata, handles)

function popupmenu1_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function text1_Callback(hObject, eventdata, handles)

function text1_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function pushbutton3_Callback(hObject, eventdata, handles)
set(handles.text1,'Style','listbox');
set(handles.text1, 'String',  {
    '% M-file for Example 7.11: ex7_11.m'
    '% Clean previous value'
    'clc'
    'clear all'
    '% Initial value'
    'V1=1;'
    'V3=0.969;'
    'Vs=230;      % kV'
    'S=complex(98.12,65.085)'
    'S_2=complex(97.09,59.932)'
    'R=0.00744    % pu, from Table 7.7'
    'X=0.03720    % pu, from Table 7.7'
    '% Solution'
    'I=abs(S)*1000/(3^(1/2)*Vs*V1)        % A, calculate value of I'
    'I_2=abs(S_2)*1000/(3^(1/2)*Vs*V3)    % A, calculate value of I_2'
    'Zbase=(Vs^2)/100                     % ohm'
    '% Calculate the loss of real part'
    'R_loss=3*I^2*R*Zbase*10^-6     % MW'
    '% Calculate the loss of imaginary part'
    'X_loss=3*I^2*X*Zbase*10^-6     % Mvar'
    },'HorizontalAlignment','left');
function slider1_Callback(hObject, eventdata, handles)
position = evalin ('base','position') ;
b = get(handles.slider1, 'Value');
set(handles.axes1, 'xlim',  [0.5  position(3)] + b );
function slider1_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

function slider2_Callback(hObject, eventdata, handles)
position = evalin ('base','position') ;
a = get(handles.slider2, 'Value');
set(handles.axes1, 'ylim',  [0.5  position(4)] - a );
function slider2_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes when uipanel1 is resized.
function uipanel1_ResizeFcn(hObject, eventdata, handles)
set(handles.axes1,'Units','pixels');
position = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized');
position;
assignin('base','position',position);
a = imread('ex7_11.png');
b = imresize(a,[position(4) position(3)],'bicubic');
c = rgb2gray(b);
c = imadjust(c,[ ],[ ],2);
imshow(c);

set(handles.slider2,'Units','pixels');
set(handles.slider2,'Min',-490);
set(handles.slider2,'Units','normalized');
