% ******************************************** %
% *** Copyright 2016 by G. W. Chang *** %
% *********** All rights reserved *********** %
% ******************************************** %
function varargout = chp7ex7(varargin)

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @chp7ex7_OpeningFcn, ...
    'gui_OutputFcn',  @chp7ex7_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

function chp7ex7_OpeningFcn(hObject, eventdata, handles, varargin)
handles.output = hObject;
imshow('ex7_7.png','parent',handles.axes1)
set(handles.axes1,'Units','pixels');
POSITION = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized');
assignin('base','position',POSITION);
guidata(hObject, handles);

function varargout = chp7ex7_OutputFcn(hObject, eventdata, handles)
varargout{1} = handles.output;


function pushbutton1_Callback(hObject, eventdata, handles)
set(handles.text2, 'String',  {
'Solve the following two nonlinear equations by using Gauss-Seidel method.'
'Maximum Power mismatch = 0.000041'
'No. of iteration = 11'
'The answer is in left hand side.'
},'HorizontalAlignment','left');
% Matlab M-file for Example 7.7: ex7_7.m@
% Clean previous value
% In ex7.7, please input data in Table 7.7
% Initial line data
y12=complex(3.815629,-19.078144);  
y13=complex(5.169561,-25.847809);
y24=complex(5.169561,-25.847809);
y34=complex(3.023705,-15.118528);
% Shunt Y
y_12=i*0.05125;                    
y_13=i*0.03875;
y_24=i*0.03875;
y_34=i*0.06375;
% Calculate Ybus
Y11=y12+y13+y_12+y_13;Y12=-y12;Y13=-y13;Y14=0; 
Y21=-y12;Y22=y12+y24+y_12+y_24;Y23=0;Y24=-y24; 
Y31=-y13;Y32=0;Y33=y13+y34+y_13+y_34;Y34=-y34; 
Y41=0;Y42=-y24;Y43=-y34;Y44=y24+y34+y_24+y_34; 
Ybus=[ Y11 Y12 Y13 Y14;              
       Y21 Y22 Y23 Y24;
       Y31 Y32 Y33 Y34;
       Y41 Y42 Y43 Y44];
P2=-1.7;                   % Initial bus 2 value
Q2=complex(0,-1.0535);
P3=-2;                     % Initial bus 3 value
Q3=complex(0,-1.2394);
P4=2.38;                   % Initial bus 4 value
% Initial voltage of each bus                
        V1(1)=1;           
        V2(1)=1;
        V3(1)=1;
        V4(1)=1.02;
        e4(1)=1;
        
j=1;                       % Iteration time:i
while(1)
    
    V2(j+1)=((P2-Q2)/(V2(j))'-Y21*V1(1)...
                 -Y23*V3(j)-Y24*V4(j))/Y22;
    V3(j+1)=((P3-Q3)/(V3(j))'-Y31*V1(1)...
                 -Y32*V2(j+1)-Y34*V4(j))/Y33;
    Q4(j+1)=-imag(conj(V4(j))*(Y41*V1(1)...
                 +Y42*V2(j+1)+Y43*V3(j+1)+Y44*V4(j)));
    V4(j+1)=((P4-1i*Q4(j+1))/(V4(j))'-Y41*V1(1)...
                 -Y42*V2(j+1)-Y43*V3(j+1))/Y44;
    % For bus 4 is voltage control bus  
    e4(j+1)=((1.02)^2-(imag(V4(j+1)))^2)^(1/2);  
    V4(j+1)=complex(e4(j+1),imag(V4(j+1)));
    if i<2
       V2_1=V2(j+1);
       V3_1=V3(j+1);
       V4_1=V4(j+1);
    end
    absolute_error=abs(V2(j+1)-V2(j));
    if j>3 & (abs(V2(j+1)-V2(j)))< 5*10^(-5)
        break;
    end
     j=j+1;
end
% Show the answer
for k=1:j          
    if (k-1)>0
        Iteration=k-1;
        V2_ans=V2(k);
        V2_angle=angle(V2_ans)*180/pi;   % rad to deg
        V3_ans=V3(k);
        V3_angle=angle(V3_ans)*180/pi;   % rad to deg
        V4_ans=V4(k);
        V4_angle=angle(V4_ans)*180/pi;   % rad to deg
    end
end
% Find current in the transmission line
I12=y12*(V1(1)-V2(j));    I13=y13*(V1(1)-V3(j));       
I21=-I12;                     I24=y24*(V2(j)-V4(j));   
I31=-I13;                     I34=y34*(V3(j)-V4(j));   
I42=-I24;                     I43=-I34;                
% Calculate line flow
S12=V1(1)*(I12)';   
S13=V1(1)*(I13)';
S1=S12+S13;
P1=real(S1*100);
Q1=imag(S1*100);
S21=V2(j)*(I21)';
S24=V2(j)*(I24)';
S2=S21+S24;
P2=real(S2*100);
Q2=imag(S2*100);
S31=V3(j)*(I31)';
S34=V3(j)*(I34)';
S3=S31+S34;
P3=real(S3*100);
Q3=imag(S3*100);
S42=V4(j)*(I42)';
S43=V4(j)*(I43)';
S4=S42+S43;
P4=real(S4*100);
Q4=imag(S4*100);
c = [abs(V1) abs(V2(j+1)) abs(V3(j+1)) abs(V4(j+1))]';
b = [angle(V1)*180/pi,angle(V2(j+1))*180/pi,angle(V3(j+1))*180/pi,angle(V4(j+1))*180/pi]';
d = [0,P2,P3,0]'
e = [0,Q2,Q3,0]'
f = [P1,0,0,P4]'
g =[Q1,0,0,Q4]'
A = [ c b d e f g]
set(handles.uitable1,'Data',A)


function pushbutton2_Callback(hObject, eventdata, handles)
close(gcf)
chapter7

function pushbutton3_Callback(hObject, eventdata, handles)

set(handles.text2, 'String',  {
'% Matlab M-file for Example 7.7: ex7_7.m@'
'% Clean previous value'
'clc'
'clear all'
'% In ex7.7, please input data in Table 7.7'
'% Initial line data'
'y12=complex(3.815629,-19.078144);  '
'y13=complex(5.169561,-25.847809);'
'y24=complex(5.169561,-25.847809);'
'y34=complex(3.023705,-15.118528);'
'% Shunt Y'
'y_12=i*0.05125;'
'y_13=i*0.03875;'
'y_24=i*0.03875;'
'y_34=i*0.06375;'
'% Calculate Ybus'
'Y11=y12+y13+y_12+y_13;Y12=-y12;Y13=-y13;Y14=0; '
'Y21=-y12;Y22=y12+y24+y_12+y_24;Y23=0;Y24=-y24; '
'Y31=-y13;Y32=0;Y33=y13+y34+y_13+y_34;Y34=-y34; '
'Y41=0;Y42=-y24;Y43=-y34;Y44=y24+y34+y_24+y_34; '
'Ybus=[ Y11 Y12 Y13 Y14;'              
'       Y21 Y22 Y23 Y24;'
'       Y31 Y32 Y33 Y34;'
'       Y41 Y42 Y43 Y44];'
'P2=-1.7;                   % Initial bus 2 value'
'Q2=complex(0,-1.0535);'
'P3=-2;                     % Initial bus 3 value'
'Q3=complex(0,-1.2394);'
'P4=2.38;                   % Initial bus 4 value'
'% Initial voltage of each bus              '  
'        V1(1)=1;'
'        V2(1)=1;'
'        V3(1)=1;'
'        V4(1)=1.02;'
'        e4(1)=1;'

'i=1;                       % Iteration time:i'
'while(1)'

'    V2(i+1)=((P2-Q2)/(V2(i))''-Y21*V1(1)...'
'                 -Y23*V3(i)-Y24*V4(i))/Y22;'
'    V3(i+1)=((P3-Q3)/(V3(i))''-Y31*V1(1)...'
'                 -Y32*V2(i+1)-Y34*V4(i))/Y33;'
'    Q4(i+1)=-imag(conj(V4(i))*(Y41*V1(1)...'
'                 +Y42*V2(i+1)+Y43*V3(i+1)+Y44*V4(i)));'
'    V4(i+1)=((P4-j*Q4(i+1))/(V4(i))''-Y41*V1(1)...'
'                 -Y42*V2(i+1)-Y43*V3(i+1))/Y44;'
'    % For bus 4 is voltage control bus  '
'    e4(i+1)=((1.02)^2-(imag(V4(i+1)))^2)^(1/2);  '
'    V4(i+1)=complex(e4(i+1),imag(V4(i+1)));'
'    if i<2'
'       V2_1=V2(i+1)'
'       V3_1=V3(i+1)'
'       V4_1=V4(i+1)'
'    end'
'    absolute_error=abs(V2(i+1)-V2(i));'
'    if i>3 & (abs(V2(i+1)-V2(i)))< 5*10^(-5)'
'        break;'
'    end'
'     i=i+1;'
'end'
'% Show the answer'
'for k=1:i'
'    if (k-1)>0'
'        Iteration=k-1;'
'        V2_ans=V2(k);'
'        V2_angle=angle(V2_ans)*180/pi;   % rad to deg'
'        V3_ans=V3(k);'
'        V3_angle=angle(V3_ans)*180/pi;   % rad to deg'
'        V4_ans=V4(k);'
'        V4_angle=angle(V4_ans)*180/pi;   % rad to deg'
'    end'
'end'
'% Find current in the transmission line'
'I12=y12*(V1(1)-V2(i));    I13=y13*(V1(1)-V3(i)); '
'I21=-I12;                     I24=y24*(V2(i)-V4(i));'
'I31=-I13;                     I34=y34*(V3(i)-V4(i));'
'I42=-I24;                     I43=-I34;'
'% Calculate line flow'
'S12=V1(1)*(I12)'';' 
'S13=V1(1)*(I13)'';'
'S1=S12+S13;'
'P1=real(S1*100);'
'Q1=imag(S1*100);'
'S21=V2(i)*(I21)'';'
'S24=V2(i)*(I24)'';'
'S2=S21+S24;'
'P2=real(S2*100);'
'Q2=imag(S2*100);'
'S31=V3(i)*(I31)'';'
'S34=V3(i)*(I34)'';'
'S3=S31+S34;'
'P3=real(S3*100);'
'Q3=imag(S3*100);'
'S42=V4(i)*(I42)'';'
'S43=V4(i)*(I43)'';'
'S4=S42+S43;'
'P4=real(S4*100);'
'Q4=imag(S4*100);'
'disp(''Solve the following two nonlinear equations by using Gauss-Seidel method'')'
'fprintf(''Maximum Power mismatch = %f \n'',abs(V2(i+1)-V2(i)));'
'fprintf(''No. of iteration = %f\n'',i+1);'
'fprintf(''Bus \t\tVoltage \t\tAngle  \t\t\t-----Load-----  \t\t--Generation--\n'')'
'fprintf(''No. \t\tMag.    \t\tDegree  \t\tMW\t\t  Mvar     \t\tMW        Mvar\n'')'
'fprintf('' 1   \t   %f\t\t   %f\t\t\t 0\t\t\t0 \t\t%f\t%f\n'',abs(V1),angle(V1)*180/pi,P1,Q1)'
'fprintf('' 2   \t   %f\t\t  %f \t%f\t%f\t\t 0\t\t\t0 \n'',abs(V2(i+1)),angle(V2(i+1))*180/pi,P2,Q2)'
'fprintf('' 3   \t   %f\t\t  %f \t%f\t%f\t\t 0\t\t\t0 \n'',abs(V3(i+1)),angle(V3(i+1))*180/pi,P3,Q3)'
'fprintf('' 4   \t   %f\t\t   %f\t\t\t 0\t\t\t0 \t\t%f\t%f\n'',abs(V4(i+1)),angle(V4(i+1))*180/pi,P4,Q4)'
    
    },'HorizontalAlignment','left');

function slider1_Callback(hObject, eventdata, handles)
position = evalin ('base','position') ;
b = get(handles.slider1, 'Value');
set(handles.axes1, 'xlim',  [0.5  position(3)] + b );
function slider1_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



function slider2_Callback(hObject, eventdata, handles)

position = evalin ('base','position') ;
a = get(handles.slider2, 'Value');
set(handles.axes1, 'ylim',  [0.5  position(4)] - a );


function slider2_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


function popupmenu1_Callback(hObject, eventdata, handles)

function popupmenu1_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes when uipanel1 is resized.
function uipanel1_ResizeFcn(hObject, eventdata, handles)
set(handles.axes1,'Units','pixels');
position = get(handles.axes1,'Position');
set(handles.axes1,'Units','normalized');
position;
assignin('base','position',position);
a = imread('ex7_7.png');
b = imresize(a,[position(4) position(3)],'bicubic');
c = rgb2gray(b);
c = imadjust(c,[ ],[ ],2);
imshow(c);

set(handles.slider2,'Units','pixels');
set(handles.slider2,'Min',-1720);
set(handles.slider2,'Units','normalized');



% --- Executes on selection change in text2.
function text2_Callback(hObject, eventdata, handles)

function text2_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
